/* QDP color generic header for _D3 */

#ifdef _QDP_COLOR_GENERIC_H
#error already included a generic header: _QDP_COLOR_GENERIC_H
#else
#define _QDP_COLOR_GENERIC_H

#define QDP_D_ColorVector QDP_D3_ColorVector
#define QDP_D_HalfFermion QDP_D3_HalfFermion
#define QDP_D_DiracFermion QDP_D3_DiracFermion
#define QDP_D_ColorMatrix QDP_D3_ColorMatrix
#define QDP_D_DiracPropagator QDP_D3_DiracPropagator

#define QDP_D_read_V(out, md, field) QDP_D3_read_V(out, md, field)
#define QDP_D_write_V(out, md, field) QDP_D3_write_V(out, md, field)
#define QDP_D_read_H(out, md, field) QDP_D3_read_H(out, md, field)
#define QDP_D_write_H(out, md, field) QDP_D3_write_H(out, md, field)
#define QDP_D_read_D(out, md, field) QDP_D3_read_D(out, md, field)
#define QDP_D_write_D(out, md, field) QDP_D3_write_D(out, md, field)
#define QDP_D_read_M(out, md, field) QDP_D3_read_M(out, md, field)
#define QDP_D_write_M(out, md, field) QDP_D3_write_M(out, md, field)
#define QDP_D_read_P(out, md, field) QDP_D3_read_P(out, md, field)
#define QDP_D_write_P(out, md, field) QDP_D3_write_P(out, md, field)
#define QDP_D_create_V(  ) \
        QDP_D3_create_V(  )
#define QDP_D_destroy_V( field ) \
        QDP_D3_destroy_V( field )
#define QDP_D_create_H(  ) \
        QDP_D3_create_H(  )
#define QDP_D_destroy_H( field ) \
        QDP_D3_destroy_H( field )
#define QDP_D_create_D(  ) \
        QDP_D3_create_D(  )
#define QDP_D_destroy_D( field ) \
        QDP_D3_destroy_D( field )
#define QDP_D_create_M(  ) \
        QDP_D3_create_M(  )
#define QDP_D_destroy_M( field ) \
        QDP_D3_destroy_M( field )
#define QDP_D_create_P(  ) \
        QDP_D3_create_P(  )
#define QDP_D_destroy_P( field ) \
        QDP_D3_destroy_P( field )
#define QDP_D_expose_V( field ) \
        QDP_D3_expose_V( field )
#define QDP_D_reset_V( field ) \
        QDP_D3_reset_V( field )
#define QDP_D_extract_V( dest, src, subset ) \
        QDP_D3_extract_V( dest, src, subset )
#define QDP_D_insert_V( dest, src, subset ) \
        QDP_D3_insert_V( dest, src, subset )
#define QDP_D_expose_H( field ) \
        QDP_D3_expose_H( field )
#define QDP_D_reset_H( field ) \
        QDP_D3_reset_H( field )
#define QDP_D_extract_H( dest, src, subset ) \
        QDP_D3_extract_H( dest, src, subset )
#define QDP_D_insert_H( dest, src, subset ) \
        QDP_D3_insert_H( dest, src, subset )
#define QDP_D_expose_D( field ) \
        QDP_D3_expose_D( field )
#define QDP_D_reset_D( field ) \
        QDP_D3_reset_D( field )
#define QDP_D_extract_D( dest, src, subset ) \
        QDP_D3_extract_D( dest, src, subset )
#define QDP_D_insert_D( dest, src, subset ) \
        QDP_D3_insert_D( dest, src, subset )
#define QDP_D_expose_M( field ) \
        QDP_D3_expose_M( field )
#define QDP_D_reset_M( field ) \
        QDP_D3_reset_M( field )
#define QDP_D_extract_M( dest, src, subset ) \
        QDP_D3_extract_M( dest, src, subset )
#define QDP_D_insert_M( dest, src, subset ) \
        QDP_D3_insert_M( dest, src, subset )
#define QDP_D_expose_P( field ) \
        QDP_D3_expose_P( field )
#define QDP_D_reset_P( field ) \
        QDP_D3_reset_P( field )
#define QDP_D_extract_P( dest, src, subset ) \
        QDP_D3_extract_P( dest, src, subset )
#define QDP_D_insert_P( dest, src, subset ) \
        QDP_D3_insert_P( dest, src, subset )
#define QDP_D_discard_V( field ) \
        QDP_D3_discard_V( field )
#define QDP_D_discard_H( field ) \
        QDP_D3_discard_H( field )
#define QDP_D_discard_D( field ) \
        QDP_D3_discard_D( field )
#define QDP_D_discard_M( field ) \
        QDP_D3_discard_M( field )
#define QDP_D_discard_P( field ) \
        QDP_D3_discard_P( field )
#define QDP_D_V_eq_func( dest, func, subset ) \
        QDP_D3_V_eq_func( dest, func, subset )
#define QDP_D_H_eq_func( dest, func, subset ) \
        QDP_D3_H_eq_func( dest, func, subset )
#define QDP_D_D_eq_func( dest, func, subset ) \
        QDP_D3_D_eq_func( dest, func, subset )
#define QDP_D_M_eq_func( dest, func, subset ) \
        QDP_D3_M_eq_func( dest, func, subset )
#define QDP_D_P_eq_func( dest, func, subset ) \
        QDP_D3_P_eq_func( dest, func, subset )
#define QDP_D_V_eq_sV( dest, src, shift, fb, subset ) \
        QDP_D3_V_eq_sV( dest, src, shift, fb, subset )
#define QDP_D_V_veq_sV( dest, src, shift, fb, subset, nv ) \
        QDP_D3_V_veq_sV( dest, src, shift, fb, subset, nv )
#define QDP_D_H_eq_sH( dest, src, shift, fb, subset ) \
        QDP_D3_H_eq_sH( dest, src, shift, fb, subset )
#define QDP_D_H_veq_sH( dest, src, shift, fb, subset, nv ) \
        QDP_D3_H_veq_sH( dest, src, shift, fb, subset, nv )
#define QDP_D_D_eq_sD( dest, src, shift, fb, subset ) \
        QDP_D3_D_eq_sD( dest, src, shift, fb, subset )
#define QDP_D_D_veq_sD( dest, src, shift, fb, subset, nv ) \
        QDP_D3_D_veq_sD( dest, src, shift, fb, subset, nv )
#define QDP_D_M_eq_sM( dest, src, shift, fb, subset ) \
        QDP_D3_M_eq_sM( dest, src, shift, fb, subset )
#define QDP_D_M_veq_sM( dest, src, shift, fb, subset, nv ) \
        QDP_D3_M_veq_sM( dest, src, shift, fb, subset, nv )
#define QDP_D_P_eq_sP( dest, src, shift, fb, subset ) \
        QDP_D3_P_eq_sP( dest, src, shift, fb, subset )
#define QDP_D_P_veq_sP( dest, src, shift, fb, subset, nv ) \
        QDP_D3_P_veq_sP( dest, src, shift, fb, subset, nv )
#define QDP_D_V_eq_M_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_eq_M_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_eq_Ma_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_eq_Ma_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_eq_sM_times_V( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_eq_sM_times_V( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_eq_sMa_times_V( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_eq_sMa_times_V( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_eq_sM_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_eq_sM_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_eq_sMa_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_eq_sMa_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_peq_M_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_peq_M_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_peq_Ma_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_peq_Ma_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_peq_sM_times_V( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_peq_sM_times_V( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_peq_sMa_times_V( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_peq_sMa_times_V( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_peq_sM_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_peq_sM_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_peq_sMa_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_peq_sMa_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_meq_M_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_meq_M_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_meq_Ma_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_meq_Ma_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_meq_sM_times_V( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_meq_sM_times_V( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_meq_sMa_times_V( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_meq_sMa_times_V( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_meq_sM_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_meq_sM_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_meq_sMa_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_meq_sMa_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_eqm_M_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_eqm_M_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_eqm_Ma_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_eqm_Ma_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_eqm_sM_times_V( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_eqm_sM_times_V( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_eqm_sMa_times_V( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_eqm_sMa_times_V( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_eqm_sM_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_eqm_sM_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_eqm_sMa_times_sV( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_V_eqm_sMa_times_sV( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_eq_M_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_eq_M_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_eq_Ma_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_eq_Ma_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_eq_sM_times_H( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_eq_sM_times_H( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_eq_sMa_times_H( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_eq_sMa_times_H( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_eq_sM_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_eq_sM_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_eq_sMa_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_eq_sMa_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_peq_M_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_peq_M_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_peq_Ma_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_peq_Ma_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_peq_sM_times_H( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_peq_sM_times_H( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_peq_sMa_times_H( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_peq_sMa_times_H( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_peq_sM_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_peq_sM_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_peq_sMa_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_peq_sMa_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_meq_M_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_meq_M_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_meq_Ma_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_meq_Ma_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_meq_sM_times_H( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_meq_sM_times_H( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_meq_sMa_times_H( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_meq_sMa_times_H( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_meq_sM_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_meq_sM_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_meq_sMa_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_meq_sMa_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_eqm_M_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_eqm_M_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_eqm_Ma_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_eqm_Ma_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_eqm_sM_times_H( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_eqm_sM_times_H( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_eqm_sMa_times_H( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_eqm_sMa_times_H( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_eqm_sM_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_eqm_sM_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_H_eqm_sMa_times_sH( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_H_eqm_sMa_times_sH( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_eq_M_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_eq_M_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_eq_Ma_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_eq_Ma_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_eq_sM_times_D( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_eq_sM_times_D( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_eq_sMa_times_D( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_eq_sMa_times_D( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_eq_sM_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_eq_sM_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_eq_sMa_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_eq_sMa_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_peq_M_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_peq_M_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_peq_Ma_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_peq_Ma_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_peq_sM_times_D( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_peq_sM_times_D( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_peq_sMa_times_D( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_peq_sMa_times_D( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_peq_sM_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_peq_sM_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_peq_sMa_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_peq_sMa_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_meq_M_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_meq_M_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_meq_Ma_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_meq_Ma_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_meq_sM_times_D( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_meq_sM_times_D( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_meq_sMa_times_D( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_meq_sMa_times_D( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_meq_sM_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_meq_sM_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_meq_sMa_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_meq_sMa_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_eqm_M_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_eqm_M_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_eqm_Ma_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_eqm_Ma_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_eqm_sM_times_D( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_eqm_sM_times_D( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_eqm_sMa_times_D( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_eqm_sMa_times_D( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_eqm_sM_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_eqm_sM_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_D_eqm_sMa_times_sD( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_D_eqm_sMa_times_sD( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_eq_M_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_eq_M_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_eq_Ma_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_eq_Ma_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_eq_sM_times_M( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_eq_sM_times_M( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_eq_sMa_times_M( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_eq_sMa_times_M( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_eq_sM_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_eq_sM_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_eq_sMa_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_eq_sMa_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_peq_M_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_peq_M_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_peq_Ma_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_peq_Ma_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_peq_sM_times_M( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_peq_sM_times_M( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_peq_sMa_times_M( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_peq_sMa_times_M( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_peq_sM_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_peq_sM_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_peq_sMa_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_peq_sMa_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_meq_M_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_meq_M_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_meq_Ma_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_meq_Ma_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_meq_sM_times_M( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_meq_sM_times_M( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_meq_sMa_times_M( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_meq_sMa_times_M( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_meq_sM_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_meq_sM_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_meq_sMa_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_meq_sMa_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_eqm_M_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_eqm_M_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_eqm_Ma_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_eqm_Ma_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_eqm_sM_times_M( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_eqm_sM_times_M( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_eqm_sMa_times_M( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_eqm_sMa_times_M( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_eqm_sM_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_eqm_sM_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_M_eqm_sMa_times_sM( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_M_eqm_sMa_times_sM( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_eq_M_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_eq_M_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_eq_Ma_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_eq_Ma_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_eq_sM_times_P( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_eq_sM_times_P( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_eq_sMa_times_P( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_eq_sMa_times_P( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_eq_sM_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_eq_sM_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_eq_sMa_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_eq_sMa_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_peq_M_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_peq_M_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_peq_Ma_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_peq_Ma_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_peq_sM_times_P( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_peq_sM_times_P( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_peq_sMa_times_P( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_peq_sMa_times_P( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_peq_sM_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_peq_sM_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_peq_sMa_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_peq_sMa_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_meq_M_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_meq_M_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_meq_Ma_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_meq_Ma_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_meq_sM_times_P( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_meq_sM_times_P( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_meq_sMa_times_P( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_meq_sMa_times_P( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_meq_sM_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_meq_sM_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_meq_sMa_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_meq_sMa_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_eqm_M_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_eqm_M_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_eqm_Ma_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_eqm_Ma_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_eqm_sM_times_P( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_eqm_sM_times_P( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_eqm_sMa_times_P( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_eqm_sMa_times_P( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_eqm_sM_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_eqm_sM_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_P_eqm_sMa_times_sP( dest, src1, src2, shift, fb, subset ) \
        QDP_D3_P_eqm_sMa_times_sP( dest, src1, src2, shift, fb, subset )
#define QDP_D_V_eq_zero( dest, subset ) \
        QDP_D3_V_eq_zero( dest, subset )
#define QDP_D_H_eq_zero( dest, subset ) \
        QDP_D3_H_eq_zero( dest, subset )
#define QDP_D_D_eq_zero( dest, subset ) \
        QDP_D3_D_eq_zero( dest, subset )
#define QDP_D_M_eq_zero( dest, subset ) \
        QDP_D3_M_eq_zero( dest, subset )
#define QDP_D_P_eq_zero( dest, subset ) \
        QDP_D3_P_eq_zero( dest, subset )
#define QDP_D_V_eq_v( dest, src, subset ) \
        QDP_D3_V_eq_v( dest, src, subset )
#define QDP_D_H_eq_h( dest, src, subset ) \
        QDP_D3_H_eq_h( dest, src, subset )
#define QDP_D_D_eq_d( dest, src, subset ) \
        QDP_D3_D_eq_d( dest, src, subset )
#define QDP_D_M_eq_m( dest, src, subset ) \
        QDP_D3_M_eq_m( dest, src, subset )
#define QDP_D_P_eq_p( dest, src, subset ) \
        QDP_D3_P_eq_p( dest, src, subset )
#define QDP_D_M_eq_c( dest, src, subset ) \
        QDP_D3_M_eq_c( dest, src, subset )
#define QDP_D_V_eq_gaussian_S( dest, src, subset ) \
        QDP_D3_V_eq_gaussian_S( dest, src, subset )
#define QDP_D_H_eq_gaussian_S( dest, src, subset ) \
        QDP_D3_H_eq_gaussian_S( dest, src, subset )
#define QDP_D_D_eq_gaussian_S( dest, src, subset ) \
        QDP_D3_D_eq_gaussian_S( dest, src, subset )
#define QDP_D_M_eq_gaussian_S( dest, src, subset ) \
        QDP_D3_M_eq_gaussian_S( dest, src, subset )
#define QDP_D_P_eq_gaussian_S( dest, src, subset ) \
        QDP_D3_P_eq_gaussian_S( dest, src, subset )
#define QDP_D_V_eq_V( dest, src, subset ) \
        QDP_D3_V_eq_V( dest, src, subset )
#define QDP_D_H_eq_H( dest, src, subset ) \
        QDP_D3_H_eq_H( dest, src, subset )
#define QDP_D_D_eq_D( dest, src, subset ) \
        QDP_D3_D_eq_D( dest, src, subset )
#define QDP_D_M_eq_M( dest, src, subset ) \
        QDP_D3_M_eq_M( dest, src, subset )
#define QDP_D_P_eq_P( dest, src, subset ) \
        QDP_D3_P_eq_P( dest, src, subset )
#define QDP_D_V_veq_V( dest, src, subset, nv ) \
        QDP_D3_V_veq_V( dest, src, subset, nv )
#define QDP_D_H_veq_H( dest, src, subset, nv ) \
        QDP_D3_H_veq_H( dest, src, subset, nv )
#define QDP_D_D_veq_D( dest, src, subset, nv ) \
        QDP_D3_D_veq_D( dest, src, subset, nv )
#define QDP_D_M_veq_M( dest, src, subset, nv ) \
        QDP_D3_M_veq_M( dest, src, subset, nv )
#define QDP_D_P_veq_P( dest, src, subset, nv ) \
        QDP_D3_P_veq_P( dest, src, subset, nv )
#define QDP_D_V_eqm_V( dest, src, subset ) \
        QDP_D3_V_eqm_V( dest, src, subset )
#define QDP_D_H_eqm_H( dest, src, subset ) \
        QDP_D3_H_eqm_H( dest, src, subset )
#define QDP_D_D_eqm_D( dest, src, subset ) \
        QDP_D3_D_eqm_D( dest, src, subset )
#define QDP_D_M_eqm_M( dest, src, subset ) \
        QDP_D3_M_eqm_M( dest, src, subset )
#define QDP_D_P_eqm_P( dest, src, subset ) \
        QDP_D3_P_eqm_P( dest, src, subset )
#define QDP_D_V_peq_V( dest, src, subset ) \
        QDP_D3_V_peq_V( dest, src, subset )
#define QDP_D_H_peq_H( dest, src, subset ) \
        QDP_D3_H_peq_H( dest, src, subset )
#define QDP_D_D_peq_D( dest, src, subset ) \
        QDP_D3_D_peq_D( dest, src, subset )
#define QDP_D_M_peq_M( dest, src, subset ) \
        QDP_D3_M_peq_M( dest, src, subset )
#define QDP_D_P_peq_P( dest, src, subset ) \
        QDP_D3_P_peq_P( dest, src, subset )
#define QDP_D_V_meq_V( dest, src, subset ) \
        QDP_D3_V_meq_V( dest, src, subset )
#define QDP_D_H_meq_H( dest, src, subset ) \
        QDP_D3_H_meq_H( dest, src, subset )
#define QDP_D_D_meq_D( dest, src, subset ) \
        QDP_D3_D_meq_D( dest, src, subset )
#define QDP_D_M_meq_M( dest, src, subset ) \
        QDP_D3_M_meq_M( dest, src, subset )
#define QDP_D_P_meq_P( dest, src, subset ) \
        QDP_D3_P_meq_P( dest, src, subset )
#define QDP_D_V_veqm_V( dest, src, subset, nv ) \
        QDP_D3_V_veqm_V( dest, src, subset, nv )
#define QDP_D_H_veqm_H( dest, src, subset, nv ) \
        QDP_D3_H_veqm_H( dest, src, subset, nv )
#define QDP_D_D_veqm_D( dest, src, subset, nv ) \
        QDP_D3_D_veqm_D( dest, src, subset, nv )
#define QDP_D_M_veqm_M( dest, src, subset, nv ) \
        QDP_D3_M_veqm_M( dest, src, subset, nv )
#define QDP_D_P_veqm_P( dest, src, subset, nv ) \
        QDP_D3_P_veqm_P( dest, src, subset, nv )
#define QDP_D_V_vpeq_V( dest, src, subset, nv ) \
        QDP_D3_V_vpeq_V( dest, src, subset, nv )
#define QDP_D_H_vpeq_H( dest, src, subset, nv ) \
        QDP_D3_H_vpeq_H( dest, src, subset, nv )
#define QDP_D_D_vpeq_D( dest, src, subset, nv ) \
        QDP_D3_D_vpeq_D( dest, src, subset, nv )
#define QDP_D_M_vpeq_M( dest, src, subset, nv ) \
        QDP_D3_M_vpeq_M( dest, src, subset, nv )
#define QDP_D_P_vpeq_P( dest, src, subset, nv ) \
        QDP_D3_P_vpeq_P( dest, src, subset, nv )
#define QDP_D_V_vmeq_V( dest, src, subset, nv ) \
        QDP_D3_V_vmeq_V( dest, src, subset, nv )
#define QDP_D_H_vmeq_H( dest, src, subset, nv ) \
        QDP_D3_H_vmeq_H( dest, src, subset, nv )
#define QDP_D_D_vmeq_D( dest, src, subset, nv ) \
        QDP_D3_D_vmeq_D( dest, src, subset, nv )
#define QDP_D_M_vmeq_M( dest, src, subset, nv ) \
        QDP_D3_M_vmeq_M( dest, src, subset, nv )
#define QDP_D_P_vmeq_P( dest, src, subset, nv ) \
        QDP_D3_P_vmeq_P( dest, src, subset, nv )
#define QDP_D_M_eq_transpose_M( dest, src, subset ) \
        QDP_D3_M_eq_transpose_M( dest, src, subset )
#define QDP_D_P_eq_transpose_P( dest, src, subset ) \
        QDP_D3_P_eq_transpose_P( dest, src, subset )
#define QDP_D_M_peq_transpose_M( dest, src, subset ) \
        QDP_D3_M_peq_transpose_M( dest, src, subset )
#define QDP_D_P_peq_transpose_P( dest, src, subset ) \
        QDP_D3_P_peq_transpose_P( dest, src, subset )
#define QDP_D_M_meq_transpose_M( dest, src, subset ) \
        QDP_D3_M_meq_transpose_M( dest, src, subset )
#define QDP_D_P_meq_transpose_P( dest, src, subset ) \
        QDP_D3_P_meq_transpose_P( dest, src, subset )
#define QDP_D_M_eqm_transpose_M( dest, src, subset ) \
        QDP_D3_M_eqm_transpose_M( dest, src, subset )
#define QDP_D_P_eqm_transpose_P( dest, src, subset ) \
        QDP_D3_P_eqm_transpose_P( dest, src, subset )
#define QDP_D_V_eq_conj_V( dest, src, subset ) \
        QDP_D3_V_eq_conj_V( dest, src, subset )
#define QDP_D_H_eq_conj_H( dest, src, subset ) \
        QDP_D3_H_eq_conj_H( dest, src, subset )
#define QDP_D_D_eq_conj_D( dest, src, subset ) \
        QDP_D3_D_eq_conj_D( dest, src, subset )
#define QDP_D_M_eq_conj_M( dest, src, subset ) \
        QDP_D3_M_eq_conj_M( dest, src, subset )
#define QDP_D_P_eq_conj_P( dest, src, subset ) \
        QDP_D3_P_eq_conj_P( dest, src, subset )
#define QDP_D_V_peq_conj_V( dest, src, subset ) \
        QDP_D3_V_peq_conj_V( dest, src, subset )
#define QDP_D_H_peq_conj_H( dest, src, subset ) \
        QDP_D3_H_peq_conj_H( dest, src, subset )
#define QDP_D_D_peq_conj_D( dest, src, subset ) \
        QDP_D3_D_peq_conj_D( dest, src, subset )
#define QDP_D_M_peq_conj_M( dest, src, subset ) \
        QDP_D3_M_peq_conj_M( dest, src, subset )
#define QDP_D_P_peq_conj_P( dest, src, subset ) \
        QDP_D3_P_peq_conj_P( dest, src, subset )
#define QDP_D_V_meq_conj_V( dest, src, subset ) \
        QDP_D3_V_meq_conj_V( dest, src, subset )
#define QDP_D_H_meq_conj_H( dest, src, subset ) \
        QDP_D3_H_meq_conj_H( dest, src, subset )
#define QDP_D_D_meq_conj_D( dest, src, subset ) \
        QDP_D3_D_meq_conj_D( dest, src, subset )
#define QDP_D_M_meq_conj_M( dest, src, subset ) \
        QDP_D3_M_meq_conj_M( dest, src, subset )
#define QDP_D_P_meq_conj_P( dest, src, subset ) \
        QDP_D3_P_meq_conj_P( dest, src, subset )
#define QDP_D_V_eqm_conj_V( dest, src, subset ) \
        QDP_D3_V_eqm_conj_V( dest, src, subset )
#define QDP_D_H_eqm_conj_H( dest, src, subset ) \
        QDP_D3_H_eqm_conj_H( dest, src, subset )
#define QDP_D_D_eqm_conj_D( dest, src, subset ) \
        QDP_D3_D_eqm_conj_D( dest, src, subset )
#define QDP_D_M_eqm_conj_M( dest, src, subset ) \
        QDP_D3_M_eqm_conj_M( dest, src, subset )
#define QDP_D_P_eqm_conj_P( dest, src, subset ) \
        QDP_D3_P_eqm_conj_P( dest, src, subset )
#define QDP_D_M_eq_Ma( dest, src, subset ) \
        QDP_D3_M_eq_Ma( dest, src, subset )
#define QDP_D_P_eq_Pa( dest, src, subset ) \
        QDP_D3_P_eq_Pa( dest, src, subset )
#define QDP_D_M_peq_Ma( dest, src, subset ) \
        QDP_D3_M_peq_Ma( dest, src, subset )
#define QDP_D_P_peq_Pa( dest, src, subset ) \
        QDP_D3_P_peq_Pa( dest, src, subset )
#define QDP_D_M_meq_Ma( dest, src, subset ) \
        QDP_D3_M_meq_Ma( dest, src, subset )
#define QDP_D_P_meq_Pa( dest, src, subset ) \
        QDP_D3_P_meq_Pa( dest, src, subset )
#define QDP_D_M_eqm_Ma( dest, src, subset ) \
        QDP_D3_M_eqm_Ma( dest, src, subset )
#define QDP_D_P_eqm_Pa( dest, src, subset ) \
        QDP_D3_P_eqm_Pa( dest, src, subset )
#define QDP_D_R_eq_norm2_V( dest, src, subset ) \
        QDP_D3_R_eq_norm2_V( dest, src, subset )
#define QDP_D_R_eq_norm2_H( dest, src, subset ) \
        QDP_D3_R_eq_norm2_H( dest, src, subset )
#define QDP_D_R_eq_norm2_D( dest, src, subset ) \
        QDP_D3_R_eq_norm2_D( dest, src, subset )
#define QDP_D_R_eq_norm2_M( dest, src, subset ) \
        QDP_D3_R_eq_norm2_M( dest, src, subset )
#define QDP_D_R_eq_norm2_P( dest, src, subset ) \
        QDP_D3_R_eq_norm2_P( dest, src, subset )
#define QDP_D_C_eq_elem_M( dest, src, i, j, subset ) \
        QDP_D3_C_eq_elem_M( dest, src, i, j, subset )
#define QDP_D_M_eq_elem_C( dest, src, i, j, subset ) \
        QDP_D3_M_eq_elem_C( dest, src, i, j, subset )
#define QDP_D_C_eq_elem_H( dest, src, color, spin, subset ) \
        QDP_D3_C_eq_elem_H( dest, src, color, spin, subset )
#define QDP_D_C_eq_elem_D( dest, src, color, spin, subset ) \
        QDP_D3_C_eq_elem_D( dest, src, color, spin, subset )
#define QDP_D_H_eq_elem_C( dest, src, color, spin, subset ) \
        QDP_D3_H_eq_elem_C( dest, src, color, spin, subset )
#define QDP_D_D_eq_elem_C( dest, src, color, spin, subset ) \
        QDP_D3_D_eq_elem_C( dest, src, color, spin, subset )
#define QDP_D_C_eq_elem_V( dest, src, i, subset ) \
        QDP_D3_C_eq_elem_V( dest, src, i, subset )
#define QDP_D_V_eq_elem_C( dest, src, i, subset ) \
        QDP_D3_V_eq_elem_C( dest, src, i, subset )
#define QDP_D_C_eq_elem_P( dest, src, ic, is, jc, js, subset ) \
        QDP_D3_C_eq_elem_P( dest, src, ic, is, jc, js, subset )
#define QDP_D_P_eq_elem_C( dest, src, ic, is, jc, js, subset ) \
        QDP_D3_P_eq_elem_C( dest, src, ic, is, jc, js, subset )
#define QDP_D_V_eq_colorvec_M( dest, src, j, subset ) \
        QDP_D3_V_eq_colorvec_M( dest, src, j, subset )
#define QDP_D_M_eq_colorvec_V( dest, src, j, subset ) \
        QDP_D3_M_eq_colorvec_V( dest, src, j, subset )
#define QDP_D_V_eq_colorvec_H( dest, src, spin, subset ) \
        QDP_D3_V_eq_colorvec_H( dest, src, spin, subset )
#define QDP_D_V_eq_colorvec_D( dest, src, spin, subset ) \
        QDP_D3_V_eq_colorvec_D( dest, src, spin, subset )
#define QDP_D_H_eq_colorvec_V( dest, src, spin, subset ) \
        QDP_D3_H_eq_colorvec_V( dest, src, spin, subset )
#define QDP_D_D_eq_colorvec_V( dest, src, spin, subset ) \
        QDP_D3_D_eq_colorvec_V( dest, src, spin, subset )
#define QDP_D_D_eq_diracvec_P( dest, src, jc, js, subset ) \
        QDP_D3_D_eq_diracvec_P( dest, src, jc, js, subset )
#define QDP_D_P_eq_diracvec_D( dest, src, jc, js, subset ) \
        QDP_D3_P_eq_diracvec_D( dest, src, jc, js, subset )
#define QDP_D_C_eq_trace_M( dest, src, subset ) \
        QDP_D3_C_eq_trace_M( dest, src, subset )
#define QDP_D_R_eq_re_trace_M( dest, src, subset ) \
        QDP_D3_R_eq_re_trace_M( dest, src, subset )
#define QDP_D_R_eq_im_trace_M( dest, src, subset ) \
        QDP_D3_R_eq_im_trace_M( dest, src, subset )
#define QDP_D_M_eq_antiherm_M( dest, src, subset ) \
        QDP_D3_M_eq_antiherm_M( dest, src, subset )
#define QDP_D_M_eq_spintrace_P( dest, src, subset ) \
        QDP_D3_M_eq_spintrace_P( dest, src, subset )
#define QDP_D_H_eq_spproj_D( dest, src, dir, sign, subset ) \
        QDP_D3_H_eq_spproj_D( dest, src, dir, sign, subset )
#define QDP_D_H_veq_spproj_D( dest, src, dir, sign, subset, nv ) \
        QDP_D3_H_veq_spproj_D( dest, src, dir, sign, subset, nv )
#define QDP_D_D_eq_sprecon_H( dest, src, dir, sign, subset ) \
        QDP_D3_D_eq_sprecon_H( dest, src, dir, sign, subset )
#define QDP_D_D_peq_sprecon_H( dest, src, dir, sign, subset ) \
        QDP_D3_D_peq_sprecon_H( dest, src, dir, sign, subset )
#define QDP_D_D_meq_sprecon_H( dest, src, dir, sign, subset ) \
        QDP_D3_D_meq_sprecon_H( dest, src, dir, sign, subset )
#define QDP_D_D_eqm_sprecon_H( dest, src, dir, sign, subset ) \
        QDP_D3_D_eqm_sprecon_H( dest, src, dir, sign, subset )
#define QDP_D_D_veq_sprecon_H( dest, src, dir, sign, subset, nv ) \
        QDP_D3_D_veq_sprecon_H( dest, src, dir, sign, subset, nv )
#define QDP_D_D_vpeq_sprecon_H( dest, src, dir, sign, subset, nv ) \
        QDP_D3_D_vpeq_sprecon_H( dest, src, dir, sign, subset, nv )
#define QDP_D_D_vmeq_sprecon_H( dest, src, dir, sign, subset, nv ) \
        QDP_D3_D_vmeq_sprecon_H( dest, src, dir, sign, subset, nv )
#define QDP_D_D_veqm_sprecon_H( dest, src, dir, sign, subset, nv ) \
        QDP_D3_D_veqm_sprecon_H( dest, src, dir, sign, subset, nv )
#define QDP_D_D_eq_sprecon_M_times_H( dest, src1, src2, dir, sign, subset ) \
        QDP_D3_D_eq_sprecon_M_times_H( dest, src1, src2, dir, sign, subset )
#define QDP_D_D_peq_sprecon_M_times_H( dest, src1, src2, dir, sign, subset ) \
        QDP_D3_D_peq_sprecon_M_times_H( dest, src1, src2, dir, sign, subset )
#define QDP_D_D_meq_sprecon_M_times_H( dest, src1, src2, dir, sign, subset ) \
        QDP_D3_D_meq_sprecon_M_times_H( dest, src1, src2, dir, sign, subset )
#define QDP_D_D_eqm_sprecon_M_times_H( dest, src1, src2, dir, sign, subset ) \
        QDP_D3_D_eqm_sprecon_M_times_H( dest, src1, src2, dir, sign, subset )
#define QDP_D_D_veq_sprecon_M_times_H( dest, src1, src2, dir, sign, subset, nv ) \
        QDP_D3_D_veq_sprecon_M_times_H( dest, src1, src2, dir, sign, subset, nv )
#define QDP_D_D_vpeq_sprecon_M_times_H( dest, src1, src2, dir, sign, subset, nv ) \
        QDP_D3_D_vpeq_sprecon_M_times_H( dest, src1, src2, dir, sign, subset, nv )
#define QDP_D_D_vmeq_sprecon_M_times_H( dest, src1, src2, dir, sign, subset, nv ) \
        QDP_D3_D_vmeq_sprecon_M_times_H( dest, src1, src2, dir, sign, subset, nv )
#define QDP_D_D_veqm_sprecon_M_times_H( dest, src1, src2, dir, sign, subset, nv ) \
        QDP_D3_D_veqm_sprecon_M_times_H( dest, src1, src2, dir, sign, subset, nv )
#define QDP_D_D_eq_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset ) \
        QDP_D3_D_eq_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset )
#define QDP_D_D_peq_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset ) \
        QDP_D3_D_peq_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset )
#define QDP_D_D_meq_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset ) \
        QDP_D3_D_meq_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset )
#define QDP_D_D_eqm_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset ) \
        QDP_D3_D_eqm_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset )
#define QDP_D_D_veq_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset, nv ) \
        QDP_D3_D_veq_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset, nv )
#define QDP_D_D_vpeq_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset, nv ) \
        QDP_D3_D_vpeq_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset, nv )
#define QDP_D_D_vmeq_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset, nv ) \
        QDP_D3_D_vmeq_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset, nv )
#define QDP_D_D_veqm_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset, nv ) \
        QDP_D3_D_veqm_wilsonspin_M_times_D( dest, src1, src2, dir, sign, subset, nv )
#define QDP_D_V_eq_r_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_eq_r_times_V( dest, src1, src2, subset )
#define QDP_D_H_eq_r_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_eq_r_times_H( dest, src1, src2, subset )
#define QDP_D_D_eq_r_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_eq_r_times_D( dest, src1, src2, subset )
#define QDP_D_M_eq_r_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_eq_r_times_M( dest, src1, src2, subset )
#define QDP_D_P_eq_r_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_eq_r_times_P( dest, src1, src2, subset )
#define QDP_D_V_peq_r_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_peq_r_times_V( dest, src1, src2, subset )
#define QDP_D_H_peq_r_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_peq_r_times_H( dest, src1, src2, subset )
#define QDP_D_D_peq_r_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_peq_r_times_D( dest, src1, src2, subset )
#define QDP_D_M_peq_r_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_peq_r_times_M( dest, src1, src2, subset )
#define QDP_D_P_peq_r_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_peq_r_times_P( dest, src1, src2, subset )
#define QDP_D_V_meq_r_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_meq_r_times_V( dest, src1, src2, subset )
#define QDP_D_H_meq_r_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_meq_r_times_H( dest, src1, src2, subset )
#define QDP_D_D_meq_r_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_meq_r_times_D( dest, src1, src2, subset )
#define QDP_D_M_meq_r_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_meq_r_times_M( dest, src1, src2, subset )
#define QDP_D_P_meq_r_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_meq_r_times_P( dest, src1, src2, subset )
#define QDP_D_V_eqm_r_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_eqm_r_times_V( dest, src1, src2, subset )
#define QDP_D_H_eqm_r_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_eqm_r_times_H( dest, src1, src2, subset )
#define QDP_D_D_eqm_r_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_eqm_r_times_D( dest, src1, src2, subset )
#define QDP_D_M_eqm_r_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_eqm_r_times_M( dest, src1, src2, subset )
#define QDP_D_P_eqm_r_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_eqm_r_times_P( dest, src1, src2, subset )
#define QDP_D_V_eq_c_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_eq_c_times_V( dest, src1, src2, subset )
#define QDP_D_H_eq_c_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_eq_c_times_H( dest, src1, src2, subset )
#define QDP_D_D_eq_c_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_eq_c_times_D( dest, src1, src2, subset )
#define QDP_D_M_eq_c_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_eq_c_times_M( dest, src1, src2, subset )
#define QDP_D_P_eq_c_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_eq_c_times_P( dest, src1, src2, subset )
#define QDP_D_V_peq_c_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_peq_c_times_V( dest, src1, src2, subset )
#define QDP_D_H_peq_c_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_peq_c_times_H( dest, src1, src2, subset )
#define QDP_D_D_peq_c_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_peq_c_times_D( dest, src1, src2, subset )
#define QDP_D_M_peq_c_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_peq_c_times_M( dest, src1, src2, subset )
#define QDP_D_P_peq_c_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_peq_c_times_P( dest, src1, src2, subset )
#define QDP_D_V_meq_c_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_meq_c_times_V( dest, src1, src2, subset )
#define QDP_D_H_meq_c_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_meq_c_times_H( dest, src1, src2, subset )
#define QDP_D_D_meq_c_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_meq_c_times_D( dest, src1, src2, subset )
#define QDP_D_M_meq_c_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_meq_c_times_M( dest, src1, src2, subset )
#define QDP_D_P_meq_c_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_meq_c_times_P( dest, src1, src2, subset )
#define QDP_D_V_eqm_c_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_eqm_c_times_V( dest, src1, src2, subset )
#define QDP_D_H_eqm_c_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_eqm_c_times_H( dest, src1, src2, subset )
#define QDP_D_D_eqm_c_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_eqm_c_times_D( dest, src1, src2, subset )
#define QDP_D_M_eqm_c_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_eqm_c_times_M( dest, src1, src2, subset )
#define QDP_D_P_eqm_c_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_eqm_c_times_P( dest, src1, src2, subset )
#define QDP_D_V_eq_i_V( dest, src, subset ) \
        QDP_D3_V_eq_i_V( dest, src, subset )
#define QDP_D_H_eq_i_H( dest, src, subset ) \
        QDP_D3_H_eq_i_H( dest, src, subset )
#define QDP_D_D_eq_i_D( dest, src, subset ) \
        QDP_D3_D_eq_i_D( dest, src, subset )
#define QDP_D_M_eq_i_M( dest, src, subset ) \
        QDP_D3_M_eq_i_M( dest, src, subset )
#define QDP_D_P_eq_i_P( dest, src, subset ) \
        QDP_D3_P_eq_i_P( dest, src, subset )
#define QDP_D_V_peq_i_V( dest, src, subset ) \
        QDP_D3_V_peq_i_V( dest, src, subset )
#define QDP_D_H_peq_i_H( dest, src, subset ) \
        QDP_D3_H_peq_i_H( dest, src, subset )
#define QDP_D_D_peq_i_D( dest, src, subset ) \
        QDP_D3_D_peq_i_D( dest, src, subset )
#define QDP_D_M_peq_i_M( dest, src, subset ) \
        QDP_D3_M_peq_i_M( dest, src, subset )
#define QDP_D_P_peq_i_P( dest, src, subset ) \
        QDP_D3_P_peq_i_P( dest, src, subset )
#define QDP_D_V_meq_i_V( dest, src, subset ) \
        QDP_D3_V_meq_i_V( dest, src, subset )
#define QDP_D_H_meq_i_H( dest, src, subset ) \
        QDP_D3_H_meq_i_H( dest, src, subset )
#define QDP_D_D_meq_i_D( dest, src, subset ) \
        QDP_D3_D_meq_i_D( dest, src, subset )
#define QDP_D_M_meq_i_M( dest, src, subset ) \
        QDP_D3_M_meq_i_M( dest, src, subset )
#define QDP_D_P_meq_i_P( dest, src, subset ) \
        QDP_D3_P_meq_i_P( dest, src, subset )
#define QDP_D_V_eqm_i_V( dest, src, subset ) \
        QDP_D3_V_eqm_i_V( dest, src, subset )
#define QDP_D_H_eqm_i_H( dest, src, subset ) \
        QDP_D3_H_eqm_i_H( dest, src, subset )
#define QDP_D_D_eqm_i_D( dest, src, subset ) \
        QDP_D3_D_eqm_i_D( dest, src, subset )
#define QDP_D_M_eqm_i_M( dest, src, subset ) \
        QDP_D3_M_eqm_i_M( dest, src, subset )
#define QDP_D_P_eqm_i_P( dest, src, subset ) \
        QDP_D3_P_eqm_i_P( dest, src, subset )
#define QDP_D_D_eq_gamma_times_D( dest, src, i, subset ) \
        QDP_D3_D_eq_gamma_times_D( dest, src, i, subset )
#define QDP_D_P_eq_gamma_times_P( dest, src, i, subset ) \
        QDP_D3_P_eq_gamma_times_P( dest, src, i, subset )
#define QDP_D_P_eq_P_times_gamma( dest, src, i, subset ) \
        QDP_D3_P_eq_P_times_gamma( dest, src, i, subset )
#define QDP_D_V_eq_V_plus_V( dest, src1, src2, subset ) \
        QDP_D3_V_eq_V_plus_V( dest, src1, src2, subset )
#define QDP_D_H_eq_H_plus_H( dest, src1, src2, subset ) \
        QDP_D3_H_eq_H_plus_H( dest, src1, src2, subset )
#define QDP_D_D_eq_D_plus_D( dest, src1, src2, subset ) \
        QDP_D3_D_eq_D_plus_D( dest, src1, src2, subset )
#define QDP_D_M_eq_M_plus_M( dest, src1, src2, subset ) \
        QDP_D3_M_eq_M_plus_M( dest, src1, src2, subset )
#define QDP_D_P_eq_P_plus_P( dest, src1, src2, subset ) \
        QDP_D3_P_eq_P_plus_P( dest, src1, src2, subset )
#define QDP_D_V_eq_V_minus_V( dest, src1, src2, subset ) \
        QDP_D3_V_eq_V_minus_V( dest, src1, src2, subset )
#define QDP_D_H_eq_H_minus_H( dest, src1, src2, subset ) \
        QDP_D3_H_eq_H_minus_H( dest, src1, src2, subset )
#define QDP_D_D_eq_D_minus_D( dest, src1, src2, subset ) \
        QDP_D3_D_eq_D_minus_D( dest, src1, src2, subset )
#define QDP_D_M_eq_M_minus_M( dest, src1, src2, subset ) \
        QDP_D3_M_eq_M_minus_M( dest, src1, src2, subset )
#define QDP_D_P_eq_P_minus_P( dest, src1, src2, subset ) \
        QDP_D3_P_eq_P_minus_P( dest, src1, src2, subset )
#define QDP_D_P_eq_P_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_eq_P_times_P( dest, src1, src2, subset )
#define QDP_D_P_peq_P_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_peq_P_times_P( dest, src1, src2, subset )
#define QDP_D_P_meq_P_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_meq_P_times_P( dest, src1, src2, subset )
#define QDP_D_P_eqm_P_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_eqm_P_times_P( dest, src1, src2, subset )
#define QDP_D_V_eq_M_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_eq_M_times_V( dest, src1, src2, subset )
#define QDP_D_H_eq_M_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_eq_M_times_H( dest, src1, src2, subset )
#define QDP_D_D_eq_M_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_eq_M_times_D( dest, src1, src2, subset )
#define QDP_D_M_eq_M_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_eq_M_times_M( dest, src1, src2, subset )
#define QDP_D_P_eq_M_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_eq_M_times_P( dest, src1, src2, subset )
#define QDP_D_V_peq_M_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_peq_M_times_V( dest, src1, src2, subset )
#define QDP_D_H_peq_M_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_peq_M_times_H( dest, src1, src2, subset )
#define QDP_D_D_peq_M_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_peq_M_times_D( dest, src1, src2, subset )
#define QDP_D_M_peq_M_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_peq_M_times_M( dest, src1, src2, subset )
#define QDP_D_P_peq_M_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_peq_M_times_P( dest, src1, src2, subset )
#define QDP_D_V_meq_M_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_meq_M_times_V( dest, src1, src2, subset )
#define QDP_D_H_meq_M_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_meq_M_times_H( dest, src1, src2, subset )
#define QDP_D_D_meq_M_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_meq_M_times_D( dest, src1, src2, subset )
#define QDP_D_M_meq_M_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_meq_M_times_M( dest, src1, src2, subset )
#define QDP_D_P_meq_M_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_meq_M_times_P( dest, src1, src2, subset )
#define QDP_D_V_eqm_M_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_eqm_M_times_V( dest, src1, src2, subset )
#define QDP_D_H_eqm_M_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_eqm_M_times_H( dest, src1, src2, subset )
#define QDP_D_D_eqm_M_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_eqm_M_times_D( dest, src1, src2, subset )
#define QDP_D_M_eqm_M_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_eqm_M_times_M( dest, src1, src2, subset )
#define QDP_D_P_eqm_M_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_eqm_M_times_P( dest, src1, src2, subset )
#define QDP_D_V_veq_M_times_V( dest, src1, src2, subset, nv ) \
        QDP_D3_V_veq_M_times_V( dest, src1, src2, subset, nv )
#define QDP_D_H_veq_M_times_H( dest, src1, src2, subset, nv ) \
        QDP_D3_H_veq_M_times_H( dest, src1, src2, subset, nv )
#define QDP_D_D_veq_M_times_D( dest, src1, src2, subset, nv ) \
        QDP_D3_D_veq_M_times_D( dest, src1, src2, subset, nv )
#define QDP_D_M_veq_M_times_M( dest, src1, src2, subset, nv ) \
        QDP_D3_M_veq_M_times_M( dest, src1, src2, subset, nv )
#define QDP_D_P_veq_M_times_P( dest, src1, src2, subset, nv ) \
        QDP_D3_P_veq_M_times_P( dest, src1, src2, subset, nv )
#define QDP_D_V_vpeq_M_times_V( dest, src1, src2, subset, nv ) \
        QDP_D3_V_vpeq_M_times_V( dest, src1, src2, subset, nv )
#define QDP_D_H_vpeq_M_times_H( dest, src1, src2, subset, nv ) \
        QDP_D3_H_vpeq_M_times_H( dest, src1, src2, subset, nv )
#define QDP_D_D_vpeq_M_times_D( dest, src1, src2, subset, nv ) \
        QDP_D3_D_vpeq_M_times_D( dest, src1, src2, subset, nv )
#define QDP_D_M_vpeq_M_times_M( dest, src1, src2, subset, nv ) \
        QDP_D3_M_vpeq_M_times_M( dest, src1, src2, subset, nv )
#define QDP_D_P_vpeq_M_times_P( dest, src1, src2, subset, nv ) \
        QDP_D3_P_vpeq_M_times_P( dest, src1, src2, subset, nv )
#define QDP_D_V_vmeq_M_times_V( dest, src1, src2, subset, nv ) \
        QDP_D3_V_vmeq_M_times_V( dest, src1, src2, subset, nv )
#define QDP_D_H_vmeq_M_times_H( dest, src1, src2, subset, nv ) \
        QDP_D3_H_vmeq_M_times_H( dest, src1, src2, subset, nv )
#define QDP_D_D_vmeq_M_times_D( dest, src1, src2, subset, nv ) \
        QDP_D3_D_vmeq_M_times_D( dest, src1, src2, subset, nv )
#define QDP_D_M_vmeq_M_times_M( dest, src1, src2, subset, nv ) \
        QDP_D3_M_vmeq_M_times_M( dest, src1, src2, subset, nv )
#define QDP_D_P_vmeq_M_times_P( dest, src1, src2, subset, nv ) \
        QDP_D3_P_vmeq_M_times_P( dest, src1, src2, subset, nv )
#define QDP_D_V_veqm_M_times_V( dest, src1, src2, subset, nv ) \
        QDP_D3_V_veqm_M_times_V( dest, src1, src2, subset, nv )
#define QDP_D_H_veqm_M_times_H( dest, src1, src2, subset, nv ) \
        QDP_D3_H_veqm_M_times_H( dest, src1, src2, subset, nv )
#define QDP_D_D_veqm_M_times_D( dest, src1, src2, subset, nv ) \
        QDP_D3_D_veqm_M_times_D( dest, src1, src2, subset, nv )
#define QDP_D_M_veqm_M_times_M( dest, src1, src2, subset, nv ) \
        QDP_D3_M_veqm_M_times_M( dest, src1, src2, subset, nv )
#define QDP_D_P_veqm_M_times_P( dest, src1, src2, subset, nv ) \
        QDP_D3_P_veqm_M_times_P( dest, src1, src2, subset, nv )
#define QDP_D_V_eq_Ma_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_eq_Ma_times_V( dest, src1, src2, subset )
#define QDP_D_H_eq_Ma_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_eq_Ma_times_H( dest, src1, src2, subset )
#define QDP_D_D_eq_Ma_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_eq_Ma_times_D( dest, src1, src2, subset )
#define QDP_D_M_eq_Ma_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_eq_Ma_times_M( dest, src1, src2, subset )
#define QDP_D_P_eq_Ma_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_eq_Ma_times_P( dest, src1, src2, subset )
#define QDP_D_V_peq_Ma_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_peq_Ma_times_V( dest, src1, src2, subset )
#define QDP_D_H_peq_Ma_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_peq_Ma_times_H( dest, src1, src2, subset )
#define QDP_D_D_peq_Ma_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_peq_Ma_times_D( dest, src1, src2, subset )
#define QDP_D_M_peq_Ma_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_peq_Ma_times_M( dest, src1, src2, subset )
#define QDP_D_P_peq_Ma_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_peq_Ma_times_P( dest, src1, src2, subset )
#define QDP_D_V_meq_Ma_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_meq_Ma_times_V( dest, src1, src2, subset )
#define QDP_D_H_meq_Ma_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_meq_Ma_times_H( dest, src1, src2, subset )
#define QDP_D_D_meq_Ma_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_meq_Ma_times_D( dest, src1, src2, subset )
#define QDP_D_M_meq_Ma_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_meq_Ma_times_M( dest, src1, src2, subset )
#define QDP_D_P_meq_Ma_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_meq_Ma_times_P( dest, src1, src2, subset )
#define QDP_D_V_eqm_Ma_times_V( dest, src1, src2, subset ) \
        QDP_D3_V_eqm_Ma_times_V( dest, src1, src2, subset )
#define QDP_D_H_eqm_Ma_times_H( dest, src1, src2, subset ) \
        QDP_D3_H_eqm_Ma_times_H( dest, src1, src2, subset )
#define QDP_D_D_eqm_Ma_times_D( dest, src1, src2, subset ) \
        QDP_D3_D_eqm_Ma_times_D( dest, src1, src2, subset )
#define QDP_D_M_eqm_Ma_times_M( dest, src1, src2, subset ) \
        QDP_D3_M_eqm_Ma_times_M( dest, src1, src2, subset )
#define QDP_D_P_eqm_Ma_times_P( dest, src1, src2, subset ) \
        QDP_D3_P_eqm_Ma_times_P( dest, src1, src2, subset )
#define QDP_D_V_veq_Ma_times_V( dest, src1, src2, subset, nv ) \
        QDP_D3_V_veq_Ma_times_V( dest, src1, src2, subset, nv )
#define QDP_D_H_veq_Ma_times_H( dest, src1, src2, subset, nv ) \
        QDP_D3_H_veq_Ma_times_H( dest, src1, src2, subset, nv )
#define QDP_D_D_veq_Ma_times_D( dest, src1, src2, subset, nv ) \
        QDP_D3_D_veq_Ma_times_D( dest, src1, src2, subset, nv )
#define QDP_D_M_veq_Ma_times_M( dest, src1, src2, subset, nv ) \
        QDP_D3_M_veq_Ma_times_M( dest, src1, src2, subset, nv )
#define QDP_D_P_veq_Ma_times_P( dest, src1, src2, subset, nv ) \
        QDP_D3_P_veq_Ma_times_P( dest, src1, src2, subset, nv )
#define QDP_D_V_vpeq_Ma_times_V( dest, src1, src2, subset, nv ) \
        QDP_D3_V_vpeq_Ma_times_V( dest, src1, src2, subset, nv )
#define QDP_D_H_vpeq_Ma_times_H( dest, src1, src2, subset, nv ) \
        QDP_D3_H_vpeq_Ma_times_H( dest, src1, src2, subset, nv )
#define QDP_D_D_vpeq_Ma_times_D( dest, src1, src2, subset, nv ) \
        QDP_D3_D_vpeq_Ma_times_D( dest, src1, src2, subset, nv )
#define QDP_D_M_vpeq_Ma_times_M( dest, src1, src2, subset, nv ) \
        QDP_D3_M_vpeq_Ma_times_M( dest, src1, src2, subset, nv )
#define QDP_D_P_vpeq_Ma_times_P( dest, src1, src2, subset, nv ) \
        QDP_D3_P_vpeq_Ma_times_P( dest, src1, src2, subset, nv )
#define QDP_D_V_vmeq_Ma_times_V( dest, src1, src2, subset, nv ) \
        QDP_D3_V_vmeq_Ma_times_V( dest, src1, src2, subset, nv )
#define QDP_D_H_vmeq_Ma_times_H( dest, src1, src2, subset, nv ) \
        QDP_D3_H_vmeq_Ma_times_H( dest, src1, src2, subset, nv )
#define QDP_D_D_vmeq_Ma_times_D( dest, src1, src2, subset, nv ) \
        QDP_D3_D_vmeq_Ma_times_D( dest, src1, src2, subset, nv )
#define QDP_D_M_vmeq_Ma_times_M( dest, src1, src2, subset, nv ) \
        QDP_D3_M_vmeq_Ma_times_M( dest, src1, src2, subset, nv )
#define QDP_D_P_vmeq_Ma_times_P( dest, src1, src2, subset, nv ) \
        QDP_D3_P_vmeq_Ma_times_P( dest, src1, src2, subset, nv )
#define QDP_D_V_veqm_Ma_times_V( dest, src1, src2, subset, nv ) \
        QDP_D3_V_veqm_Ma_times_V( dest, src1, src2, subset, nv )
#define QDP_D_H_veqm_Ma_times_H( dest, src1, src2, subset, nv ) \
        QDP_D3_H_veqm_Ma_times_H( dest, src1, src2, subset, nv )
#define QDP_D_D_veqm_Ma_times_D( dest, src1, src2, subset, nv ) \
        QDP_D3_D_veqm_Ma_times_D( dest, src1, src2, subset, nv )
#define QDP_D_M_veqm_Ma_times_M( dest, src1, src2, subset, nv ) \
        QDP_D3_M_veqm_Ma_times_M( dest, src1, src2, subset, nv )
#define QDP_D_P_veqm_Ma_times_P( dest, src1, src2, subset, nv ) \
        QDP_D3_P_veqm_Ma_times_P( dest, src1, src2, subset, nv )
#define QDP_D_P_eq_P_times_M( dest, src1, src2, subset ) \
        QDP_D3_P_eq_P_times_M( dest, src1, src2, subset )
#define QDP_D_P_peq_P_times_M( dest, src1, src2, subset ) \
        QDP_D3_P_peq_P_times_M( dest, src1, src2, subset )
#define QDP_D_P_meq_P_times_M( dest, src1, src2, subset ) \
        QDP_D3_P_meq_P_times_M( dest, src1, src2, subset )
#define QDP_D_P_eqm_P_times_M( dest, src1, src2, subset ) \
        QDP_D3_P_eqm_P_times_M( dest, src1, src2, subset )
#define QDP_D_M_eq_M_times_Ma( dest, src1, src2, subset ) \
        QDP_D3_M_eq_M_times_Ma( dest, src1, src2, subset )
#define QDP_D_P_eq_P_times_Ma( dest, src1, src2, subset ) \
        QDP_D3_P_eq_P_times_Ma( dest, src1, src2, subset )
#define QDP_D_M_peq_M_times_Ma( dest, src1, src2, subset ) \
        QDP_D3_M_peq_M_times_Ma( dest, src1, src2, subset )
#define QDP_D_P_peq_P_times_Ma( dest, src1, src2, subset ) \
        QDP_D3_P_peq_P_times_Ma( dest, src1, src2, subset )
#define QDP_D_M_meq_M_times_Ma( dest, src1, src2, subset ) \
        QDP_D3_M_meq_M_times_Ma( dest, src1, src2, subset )
#define QDP_D_P_meq_P_times_Ma( dest, src1, src2, subset ) \
        QDP_D3_P_meq_P_times_Ma( dest, src1, src2, subset )
#define QDP_D_M_eqm_M_times_Ma( dest, src1, src2, subset ) \
        QDP_D3_M_eqm_M_times_Ma( dest, src1, src2, subset )
#define QDP_D_P_eqm_P_times_Ma( dest, src1, src2, subset ) \
        QDP_D3_P_eqm_P_times_Ma( dest, src1, src2, subset )
#define QDP_D_M_eq_Ma_times_Ma( dest, src1, src2, subset ) \
        QDP_D3_M_eq_Ma_times_Ma( dest, src1, src2, subset )
#define QDP_D_M_peq_Ma_times_Ma( dest, src1, src2, subset ) \
        QDP_D3_M_peq_Ma_times_Ma( dest, src1, src2, subset )
#define QDP_D_M_meq_Ma_times_Ma( dest, src1, src2, subset ) \
        QDP_D3_M_meq_Ma_times_Ma( dest, src1, src2, subset )
#define QDP_D_M_eqm_Ma_times_Ma( dest, src1, src2, subset ) \
        QDP_D3_M_eqm_Ma_times_Ma( dest, src1, src2, subset )
#define QDP_D_C_eq_V_dot_V( dest, src1, src2, subset ) \
        QDP_D3_C_eq_V_dot_V( dest, src1, src2, subset )
#define QDP_D_C_eq_H_dot_H( dest, src1, src2, subset ) \
        QDP_D3_C_eq_H_dot_H( dest, src1, src2, subset )
#define QDP_D_C_eq_D_dot_D( dest, src1, src2, subset ) \
        QDP_D3_C_eq_D_dot_D( dest, src1, src2, subset )
#define QDP_D_C_eq_M_dot_M( dest, src1, src2, subset ) \
        QDP_D3_C_eq_M_dot_M( dest, src1, src2, subset )
#define QDP_D_C_eq_P_dot_P( dest, src1, src2, subset ) \
        QDP_D3_C_eq_P_dot_P( dest, src1, src2, subset )
#define QDP_D_R_eq_re_V_dot_V( dest, src1, src2, subset ) \
        QDP_D3_R_eq_re_V_dot_V( dest, src1, src2, subset )
#define QDP_D_R_eq_re_H_dot_H( dest, src1, src2, subset ) \
        QDP_D3_R_eq_re_H_dot_H( dest, src1, src2, subset )
#define QDP_D_R_eq_re_D_dot_D( dest, src1, src2, subset ) \
        QDP_D3_R_eq_re_D_dot_D( dest, src1, src2, subset )
#define QDP_D_R_eq_re_M_dot_M( dest, src1, src2, subset ) \
        QDP_D3_R_eq_re_M_dot_M( dest, src1, src2, subset )
#define QDP_D_R_eq_re_P_dot_P( dest, src1, src2, subset ) \
        QDP_D3_R_eq_re_P_dot_P( dest, src1, src2, subset )
#define QDP_D_M_eq_V_times_Va( dest, src1, src2, subset ) \
        QDP_D3_M_eq_V_times_Va( dest, src1, src2, subset )
#define QDP_D_M_peq_V_times_Va( dest, src1, src2, subset ) \
        QDP_D3_M_peq_V_times_Va( dest, src1, src2, subset )
#define QDP_D_M_meq_V_times_Va( dest, src1, src2, subset ) \
        QDP_D3_M_meq_V_times_Va( dest, src1, src2, subset )
#define QDP_D_M_eqm_V_times_Va( dest, src1, src2, subset ) \
        QDP_D3_M_eqm_V_times_Va( dest, src1, src2, subset )
#define QDP_D_V_eq_r_times_V_plus_V( dest, c, src1, src2, subset ) \
        QDP_D3_V_eq_r_times_V_plus_V( dest, c, src1, src2, subset )
#define QDP_D_H_eq_r_times_H_plus_H( dest, c, src1, src2, subset ) \
        QDP_D3_H_eq_r_times_H_plus_H( dest, c, src1, src2, subset )
#define QDP_D_D_eq_r_times_D_plus_D( dest, c, src1, src2, subset ) \
        QDP_D3_D_eq_r_times_D_plus_D( dest, c, src1, src2, subset )
#define QDP_D_M_eq_r_times_M_plus_M( dest, c, src1, src2, subset ) \
        QDP_D3_M_eq_r_times_M_plus_M( dest, c, src1, src2, subset )
#define QDP_D_P_eq_r_times_P_plus_P( dest, c, src1, src2, subset ) \
        QDP_D3_P_eq_r_times_P_plus_P( dest, c, src1, src2, subset )
#define QDP_D_V_eq_r_times_V_minus_V( dest, c, src1, src2, subset ) \
        QDP_D3_V_eq_r_times_V_minus_V( dest, c, src1, src2, subset )
#define QDP_D_H_eq_r_times_H_minus_H( dest, c, src1, src2, subset ) \
        QDP_D3_H_eq_r_times_H_minus_H( dest, c, src1, src2, subset )
#define QDP_D_D_eq_r_times_D_minus_D( dest, c, src1, src2, subset ) \
        QDP_D3_D_eq_r_times_D_minus_D( dest, c, src1, src2, subset )
#define QDP_D_M_eq_r_times_M_minus_M( dest, c, src1, src2, subset ) \
        QDP_D3_M_eq_r_times_M_minus_M( dest, c, src1, src2, subset )
#define QDP_D_P_eq_r_times_P_minus_P( dest, c, src1, src2, subset ) \
        QDP_D3_P_eq_r_times_P_minus_P( dest, c, src1, src2, subset )
#define QDP_D_V_eq_c_times_V_plus_V( dest, c, src1, src2, subset ) \
        QDP_D3_V_eq_c_times_V_plus_V( dest, c, src1, src2, subset )
#define QDP_D_H_eq_c_times_H_plus_H( dest, c, src1, src2, subset ) \
        QDP_D3_H_eq_c_times_H_plus_H( dest, c, src1, src2, subset )
#define QDP_D_D_eq_c_times_D_plus_D( dest, c, src1, src2, subset ) \
        QDP_D3_D_eq_c_times_D_plus_D( dest, c, src1, src2, subset )
#define QDP_D_M_eq_c_times_M_plus_M( dest, c, src1, src2, subset ) \
        QDP_D3_M_eq_c_times_M_plus_M( dest, c, src1, src2, subset )
#define QDP_D_P_eq_c_times_P_plus_P( dest, c, src1, src2, subset ) \
        QDP_D3_P_eq_c_times_P_plus_P( dest, c, src1, src2, subset )
#define QDP_D_V_eq_c_times_V_minus_V( dest, c, src1, src2, subset ) \
        QDP_D3_V_eq_c_times_V_minus_V( dest, c, src1, src2, subset )
#define QDP_D_H_eq_c_times_H_minus_H( dest, c, src1, src2, subset ) \
        QDP_D3_H_eq_c_times_H_minus_H( dest, c, src1, src2, subset )
#define QDP_D_D_eq_c_times_D_minus_D( dest, c, src1, src2, subset ) \
        QDP_D3_D_eq_c_times_D_minus_D( dest, c, src1, src2, subset )
#define QDP_D_M_eq_c_times_M_minus_M( dest, c, src1, src2, subset ) \
        QDP_D3_M_eq_c_times_M_minus_M( dest, c, src1, src2, subset )
#define QDP_D_P_eq_c_times_P_minus_P( dest, c, src1, src2, subset ) \
        QDP_D3_P_eq_c_times_P_minus_P( dest, c, src1, src2, subset )
#define QDP_D_V_eq_V_mask_I( dest, src1, src2, subset ) \
        QDP_D3_V_eq_V_mask_I( dest, src1, src2, subset )
#define QDP_D_H_eq_H_mask_I( dest, src1, src2, subset ) \
        QDP_D3_H_eq_H_mask_I( dest, src1, src2, subset )
#define QDP_D_D_eq_D_mask_I( dest, src1, src2, subset ) \
        QDP_D3_D_eq_D_mask_I( dest, src1, src2, subset )
#define QDP_D_M_eq_M_mask_I( dest, src1, src2, subset ) \
        QDP_D3_M_eq_M_mask_I( dest, src1, src2, subset )
#define QDP_D_P_eq_P_mask_I( dest, src1, src2, subset ) \
        QDP_D3_P_eq_P_mask_I( dest, src1, src2, subset )
#define QDP_D_r_eq_norm2_V( dest, src, subset ) \
        QDP_D3_r_eq_norm2_V( dest, src, subset )
#define QDP_D_r_eq_norm2_H( dest, src, subset ) \
        QDP_D3_r_eq_norm2_H( dest, src, subset )
#define QDP_D_r_eq_norm2_D( dest, src, subset ) \
        QDP_D3_r_eq_norm2_D( dest, src, subset )
#define QDP_D_r_eq_norm2_M( dest, src, subset ) \
        QDP_D3_r_eq_norm2_M( dest, src, subset )
#define QDP_D_r_eq_norm2_P( dest, src, subset ) \
        QDP_D3_r_eq_norm2_P( dest, src, subset )
#define QDP_D_r_veq_norm2_V( dest, src, subset, nv ) \
        QDP_D3_r_veq_norm2_V( dest, src, subset, nv )
#define QDP_D_r_veq_norm2_H( dest, src, subset, nv ) \
        QDP_D3_r_veq_norm2_H( dest, src, subset, nv )
#define QDP_D_r_veq_norm2_D( dest, src, subset, nv ) \
        QDP_D3_r_veq_norm2_D( dest, src, subset, nv )
#define QDP_D_r_veq_norm2_M( dest, src, subset, nv ) \
        QDP_D3_r_veq_norm2_M( dest, src, subset, nv )
#define QDP_D_r_veq_norm2_P( dest, src, subset, nv ) \
        QDP_D3_r_veq_norm2_P( dest, src, subset, nv )
#define QDP_D_c_eq_V_dot_V( dest, src1, src2, subset ) \
        QDP_D3_c_eq_V_dot_V( dest, src1, src2, subset )
#define QDP_D_c_eq_H_dot_H( dest, src1, src2, subset ) \
        QDP_D3_c_eq_H_dot_H( dest, src1, src2, subset )
#define QDP_D_c_eq_D_dot_D( dest, src1, src2, subset ) \
        QDP_D3_c_eq_D_dot_D( dest, src1, src2, subset )
#define QDP_D_c_eq_M_dot_M( dest, src1, src2, subset ) \
        QDP_D3_c_eq_M_dot_M( dest, src1, src2, subset )
#define QDP_D_c_eq_P_dot_P( dest, src1, src2, subset ) \
        QDP_D3_c_eq_P_dot_P( dest, src1, src2, subset )
#define QDP_D_c_veq_V_dot_V( dest, src1, src2, subset, nv ) \
        QDP_D3_c_veq_V_dot_V( dest, src1, src2, subset, nv )
#define QDP_D_c_veq_H_dot_H( dest, src1, src2, subset, nv ) \
        QDP_D3_c_veq_H_dot_H( dest, src1, src2, subset, nv )
#define QDP_D_c_veq_D_dot_D( dest, src1, src2, subset, nv ) \
        QDP_D3_c_veq_D_dot_D( dest, src1, src2, subset, nv )
#define QDP_D_c_veq_M_dot_M( dest, src1, src2, subset, nv ) \
        QDP_D3_c_veq_M_dot_M( dest, src1, src2, subset, nv )
#define QDP_D_c_veq_P_dot_P( dest, src1, src2, subset, nv ) \
        QDP_D3_c_veq_P_dot_P( dest, src1, src2, subset, nv )
#define QDP_D_r_eq_re_V_dot_V( dest, src1, src2, subset ) \
        QDP_D3_r_eq_re_V_dot_V( dest, src1, src2, subset )
#define QDP_D_r_eq_re_H_dot_H( dest, src1, src2, subset ) \
        QDP_D3_r_eq_re_H_dot_H( dest, src1, src2, subset )
#define QDP_D_r_eq_re_D_dot_D( dest, src1, src2, subset ) \
        QDP_D3_r_eq_re_D_dot_D( dest, src1, src2, subset )
#define QDP_D_r_eq_re_M_dot_M( dest, src1, src2, subset ) \
        QDP_D3_r_eq_re_M_dot_M( dest, src1, src2, subset )
#define QDP_D_r_eq_re_P_dot_P( dest, src1, src2, subset ) \
        QDP_D3_r_eq_re_P_dot_P( dest, src1, src2, subset )
#define QDP_D_r_veq_re_V_dot_V( dest, src1, src2, subset, nv ) \
        QDP_D3_r_veq_re_V_dot_V( dest, src1, src2, subset, nv )
#define QDP_D_r_veq_re_H_dot_H( dest, src1, src2, subset, nv ) \
        QDP_D3_r_veq_re_H_dot_H( dest, src1, src2, subset, nv )
#define QDP_D_r_veq_re_D_dot_D( dest, src1, src2, subset, nv ) \
        QDP_D3_r_veq_re_D_dot_D( dest, src1, src2, subset, nv )
#define QDP_D_r_veq_re_M_dot_M( dest, src1, src2, subset, nv ) \
        QDP_D3_r_veq_re_M_dot_M( dest, src1, src2, subset, nv )
#define QDP_D_r_veq_re_P_dot_P( dest, src1, src2, subset, nv ) \
        QDP_D3_r_veq_re_P_dot_P( dest, src1, src2, subset, nv )
#define QDP_D_v_eq_sum_V( dest, src, subset ) \
        QDP_D3_v_eq_sum_V( dest, src, subset )
#define QDP_D_h_eq_sum_H( dest, src, subset ) \
        QDP_D3_h_eq_sum_H( dest, src, subset )
#define QDP_D_d_eq_sum_D( dest, src, subset ) \
        QDP_D3_d_eq_sum_D( dest, src, subset )
#define QDP_D_m_eq_sum_M( dest, src, subset ) \
        QDP_D3_m_eq_sum_M( dest, src, subset )
#define QDP_D_p_eq_sum_P( dest, src, subset ) \
        QDP_D3_p_eq_sum_P( dest, src, subset )
#define QDP_D_r_eq_norm2_V_multi( dest, src, subset, ns ) \
        QDP_D3_r_eq_norm2_V_multi( dest, src, subset, ns )
#define QDP_D_r_eq_norm2_H_multi( dest, src, subset, ns ) \
        QDP_D3_r_eq_norm2_H_multi( dest, src, subset, ns )
#define QDP_D_r_eq_norm2_D_multi( dest, src, subset, ns ) \
        QDP_D3_r_eq_norm2_D_multi( dest, src, subset, ns )
#define QDP_D_r_eq_norm2_M_multi( dest, src, subset, ns ) \
        QDP_D3_r_eq_norm2_M_multi( dest, src, subset, ns )
#define QDP_D_r_eq_norm2_P_multi( dest, src, subset, ns ) \
        QDP_D3_r_eq_norm2_P_multi( dest, src, subset, ns )
#define QDP_D_r_veq_norm2_V_multi( dest, src, subset, ns ) \
        QDP_D3_r_veq_norm2_V_multi( dest, src, subset, ns )
#define QDP_D_r_veq_norm2_H_multi( dest, src, subset, ns ) \
        QDP_D3_r_veq_norm2_H_multi( dest, src, subset, ns )
#define QDP_D_r_veq_norm2_D_multi( dest, src, subset, ns ) \
        QDP_D3_r_veq_norm2_D_multi( dest, src, subset, ns )
#define QDP_D_r_veq_norm2_M_multi( dest, src, subset, ns ) \
        QDP_D3_r_veq_norm2_M_multi( dest, src, subset, ns )
#define QDP_D_r_veq_norm2_P_multi( dest, src, subset, ns ) \
        QDP_D3_r_veq_norm2_P_multi( dest, src, subset, ns )
#define QDP_D_c_eq_V_dot_V_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_c_eq_V_dot_V_multi( dest, src1, src2, subset, ns )
#define QDP_D_c_eq_H_dot_H_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_c_eq_H_dot_H_multi( dest, src1, src2, subset, ns )
#define QDP_D_c_eq_D_dot_D_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_c_eq_D_dot_D_multi( dest, src1, src2, subset, ns )
#define QDP_D_c_eq_M_dot_M_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_c_eq_M_dot_M_multi( dest, src1, src2, subset, ns )
#define QDP_D_c_eq_P_dot_P_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_c_eq_P_dot_P_multi( dest, src1, src2, subset, ns )
#define QDP_D_c_veq_V_dot_V_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_c_veq_V_dot_V_multi( dest, src1, src2, subset, ns )
#define QDP_D_c_veq_H_dot_H_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_c_veq_H_dot_H_multi( dest, src1, src2, subset, ns )
#define QDP_D_c_veq_D_dot_D_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_c_veq_D_dot_D_multi( dest, src1, src2, subset, ns )
#define QDP_D_c_veq_M_dot_M_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_c_veq_M_dot_M_multi( dest, src1, src2, subset, ns )
#define QDP_D_c_veq_P_dot_P_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_c_veq_P_dot_P_multi( dest, src1, src2, subset, ns )
#define QDP_D_r_eq_re_V_dot_V_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_r_eq_re_V_dot_V_multi( dest, src1, src2, subset, ns )
#define QDP_D_r_eq_re_H_dot_H_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_r_eq_re_H_dot_H_multi( dest, src1, src2, subset, ns )
#define QDP_D_r_eq_re_D_dot_D_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_r_eq_re_D_dot_D_multi( dest, src1, src2, subset, ns )
#define QDP_D_r_eq_re_M_dot_M_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_r_eq_re_M_dot_M_multi( dest, src1, src2, subset, ns )
#define QDP_D_r_eq_re_P_dot_P_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_r_eq_re_P_dot_P_multi( dest, src1, src2, subset, ns )
#define QDP_D_r_veq_re_V_dot_V_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_r_veq_re_V_dot_V_multi( dest, src1, src2, subset, ns )
#define QDP_D_r_veq_re_H_dot_H_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_r_veq_re_H_dot_H_multi( dest, src1, src2, subset, ns )
#define QDP_D_r_veq_re_D_dot_D_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_r_veq_re_D_dot_D_multi( dest, src1, src2, subset, ns )
#define QDP_D_r_veq_re_M_dot_M_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_r_veq_re_M_dot_M_multi( dest, src1, src2, subset, ns )
#define QDP_D_r_veq_re_P_dot_P_multi( dest, src1, src2, subset, ns ) \
        QDP_D3_r_veq_re_P_dot_P_multi( dest, src1, src2, subset, ns )
#define QDP_D_v_eq_sum_V_multi( dest, src, subset, ns ) \
        QDP_D3_v_eq_sum_V_multi( dest, src, subset, ns )
#define QDP_D_h_eq_sum_H_multi( dest, src, subset, ns ) \
        QDP_D3_h_eq_sum_H_multi( dest, src, subset, ns )
#define QDP_D_d_eq_sum_D_multi( dest, src, subset, ns ) \
        QDP_D3_d_eq_sum_D_multi( dest, src, subset, ns )
#define QDP_D_m_eq_sum_M_multi( dest, src, subset, ns ) \
        QDP_D3_m_eq_sum_M_multi( dest, src, subset, ns )
#define QDP_D_p_eq_sum_P_multi( dest, src, subset, ns ) \
        QDP_D3_p_eq_sum_P_multi( dest, src, subset, ns )

#endif
