/*
 *  Fills and random numbers
 *
 *  Constant fills
 */

#include "qdp_d_internal.h"

void
QDP_D_C_eq_c( QDP_D_Complex *__restrict__ dest, QLA_D_Complex *src, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);

  if( subset->indexed ) {
    QLA_D_C_xeq_c( dest->data, src, subset->index, subset->len );
  } else {
    QLA_D_C_veq_c( dest->data+subset->offset, src, subset->len );
  }
}
