/*
 *  Fills and random numbers
 *
 *  Gaussian random number fills
 */

#include "qdp_d_internal.h"

void
QDP_D_R_eq_gaussian_S( QDP_D_Real *__restrict__ dest, QDP_RandomState *src, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    QLA_D_R_xeq_gaussian_S( dest->data, src->data, subset->index, subset->len );
  } else {
    QLA_D_R_veq_gaussian_S( dest->data+subset->offset, src->data+subset->offset, subset->len );
  }
}
