/*
 *  Fills and random numbers
 *
 *  Constant fills
 */

#include "qdp_d_internal.h"

void
QDP_D_R_eq_r( QDP_D_Real *__restrict__ dest, QLA_D_Real *src, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);

  if( subset->indexed ) {
    QLA_D_R_xeq_r( dest->data, src, subset->index, subset->len );
  } else {
    QLA_D_R_veq_r( dest->data+subset->offset, src, subset->len );
  }
}
