/*
 *  Fills and random numbers
 *
 *  Zero fills
 */

#include "qdp_d_internal.h"

void
QDP_D_R_eq_zero( QDP_D_Real *__restrict__ dest, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);

  if( subset->indexed ) {
    QLA_D_R_xeq_zero( dest->data, subset->index, subset->len );
  } else {
    QLA_D_R_veq_zero( dest->data+subset->offset, subset->len );
  }
}
