#include "qdp_d.h"
#include "qdp_d_internal.h"

QLA_D_Complex *
QDP_D_expose_C(QDP_D_Complex *dest)
{
  QDP_prepare_dest(&dest->dc);
  dest->dc.exposed = 1;
  return dest->data;
}

void
QDP_D_reset_C(QDP_D_Complex *dest)
{
  if(!dest->dc.exposed) {
    fprintf(stderr,"error: trying to restore non-exposed data\n");
    QDP_abort();
  }
  dest->dc.exposed = 0;
}
