/*
 *  Fills and random numbers
 *
 *  Constant fills
 */

#include "qdp_d3_internal.h"

void
QDP_D3_D_eq_d( QDP_D3_DiracFermion *__restrict__ dest, QLA_D3_DiracFermion *src, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);

  if( subset->indexed ) {
    QLA_D3_D_xeq_d( dest->data, src, subset->index, subset->len );
  } else {
    QLA_D3_D_veq_d( dest->data+subset->offset, src, subset->len );
  }
}
