/*
 *  Fills and random numbers
 *
 *  Constant fills
 */

#include "qdp_d3_internal.h"

void
QDP_D3_P_eq_p( QDP_D3_DiracPropagator *__restrict__ dest, QLA_D3_DiracPropagator *src, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);

  if( subset->indexed ) {
    QLA_D3_P_xeq_p( dest->data, src, subset->index, subset->len );
  } else {
    QLA_D3_P_veq_p( dest->data+subset->offset, src, subset->len );
  }
}
