#include <stdlib.h>
#include "qdp_d3.h"
#include "qdp_d3_internal.h"

QDP_D3_DiracFermion *
QDP_D3_create_D(void)
{
  QDP_D3_DiracFermion *m;

  m = (QDP_D3_DiracFermion *) malloc(sizeof(QDP_D3_DiracFermion));
  if(m!=NULL) {
    m->data = NULL;
    m->ptr = NULL;
    m->dc.data = (char **) &(m->data);
    m->dc.ptr = (char ***) &(m->ptr);
    m->dc.size = sizeof(QLA_D3_DiracFermion);
    m->dc.discarded = 1;
    m->dc.exposed = 0;
    m->dc.shift_src = NULL;
    m->dc.shift_dest = NULL;
  }

  return m;
}

void
QDP_D3_destroy_D(QDP_D3_DiracFermion *field)
{
  QDP_prepare_destroy(&field->dc);
  free(field->data);
  free(field->ptr);
  free(field);
}
