#include "qdp_d3.h"
#include "qdp_d3_internal.h"

QLA_D3_DiracPropagator *
QDP_D3_expose_P(QDP_D3_DiracPropagator *dest)
{
  QDP_prepare_dest(&dest->dc);
  dest->dc.exposed = 1;
  return dest->data;
}

void
QDP_D3_reset_P(QDP_D3_DiracPropagator *dest)
{
  if(!dest->dc.exposed) {
    fprintf(stderr,"error: trying to restore non-exposed data\n");
    QDP_abort();
  }
  dest->dc.exposed = 0;
}
