/*
 *  Fills and random numbers
 *
 *  Gaussian random number fills
 */

#include "qdp_f3_internal.h"

void
QDP_F3_H_eq_gaussian_S( QDP_F3_HalfFermion *__restrict__ dest, QDP_RandomState *src, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    QLA_F3_H_xeq_gaussian_S( dest->data, src->data, subset->index, subset->len );
  } else {
    QLA_F3_H_veq_gaussian_S( dest->data+subset->offset, src->data+subset->offset, subset->len );
  }
}
