#include <stdlib.h>
#include "qdp_f3.h"
#include "qdp_f3_internal.h"

QDP_F3_DiracPropagator *
QDP_F3_create_P(void)
{
  QDP_F3_DiracPropagator *m;

  m = (QDP_F3_DiracPropagator *) malloc(sizeof(QDP_F3_DiracPropagator));
  if(m!=NULL) {
    m->data = NULL;
    m->ptr = NULL;
    m->dc.data = (char **) &(m->data);
    m->dc.ptr = (char ***) &(m->ptr);
    m->dc.size = sizeof(QLA_F3_DiracPropagator);
    m->dc.discarded = 1;
    m->dc.exposed = 0;
    m->dc.shift_src = NULL;
    m->dc.shift_dest = NULL;
  }

  return m;
}

void
QDP_F3_destroy_P(QDP_F3_DiracPropagator *field)
{
  QDP_prepare_destroy(&field->dc);
  free(field->data);
  free(field->ptr);
  free(field);
}
