#include "qdp_f3.h"
#include "qdp_f3_internal.h"

QLA_F3_DiracPropagator *
QDP_F3_expose_P(QDP_F3_DiracPropagator *dest)
{
  QDP_prepare_dest(&dest->dc);
  dest->dc.exposed = 1;
  return dest->data;
}

void
QDP_F3_reset_P(QDP_F3_DiracPropagator *dest)
{
  if(!dest->dc.exposed) {
    fprintf(stderr,"error: trying to restore non-exposed data\n");
    QDP_abort();
  }
  dest->dc.exposed = 0;
}
