/*
 *  Unary Operations
 *
 *  Bitwise not
 */

#include "qdp_int_internal.h"

void
QDP_I_eq_not_I( QDP_Int *__restrict__ dest, QDP_Int *src, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_I_xeq_not_pI( dest->data, src->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_I_xeq_not_I( dest->data, src->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_I_veq_not_pI( dest->data+subset->offset, src->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_I_veq_not_I( dest->data+subset->offset, src->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
