/**********************

 QDP_DF header file

**********************/

#ifndef _QDP_DF
#define _QDP_DF

#include "qdp_common.h"
#include "qdp_types.h"
#include "qla_types.h"
#include "qla_complex.h"
#include "qla_random.h"

#ifdef __cplusplus
extern "C" {
#endif

/* create and destroy fields */


/* data access and extraction */


/* optimization */


/* set by function */


/* shift */


/* shift & multiply */


/*
 *  Type conversion and component extraction and insertion
 */

/*
 *  Convert float to double
 */

void QDP_DF_R_eq_R( QDP_D_Real *__restrict__ dest, QDP_F_Real *src, QDP_Subset subset );
void QDP_DF_C_eq_C( QDP_D_Complex *__restrict__ dest, QDP_F_Complex *src, QDP_Subset subset );

/*
 *  Convert double to float
 */

void QDP_FD_R_eq_R( QDP_F_Real *__restrict__ dest, QDP_D_Real *src, QDP_Subset subset );
void QDP_FD_C_eq_C( QDP_F_Complex *__restrict__ dest, QDP_D_Complex *src, QDP_Subset subset );

#ifdef __cplusplus
}
#endif

#ifdef QDP_PROFILE
#include "qdp_df_profile.h"
#endif

#endif
