/* QDP generic header for _F */

#ifdef _QDP_P_GENERIC_H
#error already included a generic header: _QDP_P_GENERIC_H
#else
#define _QDP_P_GENERIC_H

#define QDP_Real QDP_F_Real
#define QDP_Complex QDP_F_Complex

#define QDP_read_R(out, md, field) QDP_F_read_R(out, md, field)
#define QDP_write_R(out, md, field) QDP_F_write_R(out, md, field)
#define QDP_read_C(out, md, field) QDP_F_read_C(out, md, field)
#define QDP_write_C(out, md, field) QDP_F_write_C(out, md, field)
#define QDP_create_R(  ) \
        QDP_F_create_R(  )
#define QDP_destroy_R( field ) \
        QDP_F_destroy_R( field )
#define QDP_create_C(  ) \
        QDP_F_create_C(  )
#define QDP_destroy_C( field ) \
        QDP_F_destroy_C( field )
#define QDP_expose_R( field ) \
        QDP_F_expose_R( field )
#define QDP_reset_R( field ) \
        QDP_F_reset_R( field )
#define QDP_extract_R( dest, src, subset ) \
        QDP_F_extract_R( dest, src, subset )
#define QDP_insert_R( dest, src, subset ) \
        QDP_F_insert_R( dest, src, subset )
#define QDP_expose_C( field ) \
        QDP_F_expose_C( field )
#define QDP_reset_C( field ) \
        QDP_F_reset_C( field )
#define QDP_extract_C( dest, src, subset ) \
        QDP_F_extract_C( dest, src, subset )
#define QDP_insert_C( dest, src, subset ) \
        QDP_F_insert_C( dest, src, subset )
#define QDP_discard_R( field ) \
        QDP_F_discard_R( field )
#define QDP_discard_C( field ) \
        QDP_F_discard_C( field )
#define QDP_R_eq_func( dest, func, subset ) \
        QDP_F_R_eq_func( dest, func, subset )
#define QDP_C_eq_func( dest, func, subset ) \
        QDP_F_C_eq_func( dest, func, subset )
#define QDP_R_eq_sR( dest, src, shift, fb, subset ) \
        QDP_F_R_eq_sR( dest, src, shift, fb, subset )
#define QDP_R_veq_sR( dest, src, shift, fb, subset, nv ) \
        QDP_F_R_veq_sR( dest, src, shift, fb, subset, nv )
#define QDP_C_eq_sC( dest, src, shift, fb, subset ) \
        QDP_F_C_eq_sC( dest, src, shift, fb, subset )
#define QDP_C_veq_sC( dest, src, shift, fb, subset, nv ) \
        QDP_F_C_veq_sC( dest, src, shift, fb, subset, nv )
#define QDP_R_eq_zero( dest, subset ) \
        QDP_F_R_eq_zero( dest, subset )
#define QDP_C_eq_zero( dest, subset ) \
        QDP_F_C_eq_zero( dest, subset )
#define QDP_R_eq_r( dest, src, subset ) \
        QDP_F_R_eq_r( dest, src, subset )
#define QDP_C_eq_c( dest, src, subset ) \
        QDP_F_C_eq_c( dest, src, subset )
#define QDP_R_eq_random_S( dest, src, subset ) \
        QDP_F_R_eq_random_S( dest, src, subset )
#define QDP_R_eq_gaussian_S( dest, src, subset ) \
        QDP_F_R_eq_gaussian_S( dest, src, subset )
#define QDP_C_eq_gaussian_S( dest, src, subset ) \
        QDP_F_C_eq_gaussian_S( dest, src, subset )
#define QDP_R_eq_sin_R( dest, src, subset ) \
        QDP_F_R_eq_sin_R( dest, src, subset )
#define QDP_R_eq_cos_R( dest, src, subset ) \
        QDP_F_R_eq_cos_R( dest, src, subset )
#define QDP_R_eq_tan_R( dest, src, subset ) \
        QDP_F_R_eq_tan_R( dest, src, subset )
#define QDP_R_eq_asin_R( dest, src, subset ) \
        QDP_F_R_eq_asin_R( dest, src, subset )
#define QDP_R_eq_acos_R( dest, src, subset ) \
        QDP_F_R_eq_acos_R( dest, src, subset )
#define QDP_R_eq_atan_R( dest, src, subset ) \
        QDP_F_R_eq_atan_R( dest, src, subset )
#define QDP_R_eq_sqrt_R( dest, src, subset ) \
        QDP_F_R_eq_sqrt_R( dest, src, subset )
#define QDP_R_eq_fabs_R( dest, src, subset ) \
        QDP_F_R_eq_fabs_R( dest, src, subset )
#define QDP_R_eq_exp_R( dest, src, subset ) \
        QDP_F_R_eq_exp_R( dest, src, subset )
#define QDP_R_eq_log_R( dest, src, subset ) \
        QDP_F_R_eq_log_R( dest, src, subset )
#define QDP_R_eq_sign_R( dest, src, subset ) \
        QDP_F_R_eq_sign_R( dest, src, subset )
#define QDP_R_eq_ceil_R( dest, src, subset ) \
        QDP_F_R_eq_ceil_R( dest, src, subset )
#define QDP_R_eq_floor_R( dest, src, subset ) \
        QDP_F_R_eq_floor_R( dest, src, subset )
#define QDP_R_eq_sinh_R( dest, src, subset ) \
        QDP_F_R_eq_sinh_R( dest, src, subset )
#define QDP_R_eq_cosh_R( dest, src, subset ) \
        QDP_F_R_eq_cosh_R( dest, src, subset )
#define QDP_R_eq_tanh_R( dest, src, subset ) \
        QDP_F_R_eq_tanh_R( dest, src, subset )
#define QDP_R_eq_log10_R( dest, src, subset ) \
        QDP_F_R_eq_log10_R( dest, src, subset )
#define QDP_C_eq_cexpi_R( dest, src, subset ) \
        QDP_F_C_eq_cexpi_R( dest, src, subset )
#define QDP_R_eq_norm_C( dest, src, subset ) \
        QDP_F_R_eq_norm_C( dest, src, subset )
#define QDP_R_eq_arg_C( dest, src, subset ) \
        QDP_F_R_eq_arg_C( dest, src, subset )
#define QDP_C_eq_cexp_C( dest, src, subset ) \
        QDP_F_C_eq_cexp_C( dest, src, subset )
#define QDP_C_eq_csqrt_C( dest, src, subset ) \
        QDP_F_C_eq_csqrt_C( dest, src, subset )
#define QDP_C_eq_clog_C( dest, src, subset ) \
        QDP_F_C_eq_clog_C( dest, src, subset )
#define QDP_R_eq_R( dest, src, subset ) \
        QDP_F_R_eq_R( dest, src, subset )
#define QDP_C_eq_C( dest, src, subset ) \
        QDP_F_C_eq_C( dest, src, subset )
#define QDP_R_veq_R( dest, src, subset, nv ) \
        QDP_F_R_veq_R( dest, src, subset, nv )
#define QDP_C_veq_C( dest, src, subset, nv ) \
        QDP_F_C_veq_C( dest, src, subset, nv )
#define QDP_R_eqm_R( dest, src, subset ) \
        QDP_F_R_eqm_R( dest, src, subset )
#define QDP_C_eqm_C( dest, src, subset ) \
        QDP_F_C_eqm_C( dest, src, subset )
#define QDP_R_peq_R( dest, src, subset ) \
        QDP_F_R_peq_R( dest, src, subset )
#define QDP_C_peq_C( dest, src, subset ) \
        QDP_F_C_peq_C( dest, src, subset )
#define QDP_R_meq_R( dest, src, subset ) \
        QDP_F_R_meq_R( dest, src, subset )
#define QDP_C_meq_C( dest, src, subset ) \
        QDP_F_C_meq_C( dest, src, subset )
#define QDP_R_veqm_R( dest, src, subset, nv ) \
        QDP_F_R_veqm_R( dest, src, subset, nv )
#define QDP_C_veqm_C( dest, src, subset, nv ) \
        QDP_F_C_veqm_C( dest, src, subset, nv )
#define QDP_R_vpeq_R( dest, src, subset, nv ) \
        QDP_F_R_vpeq_R( dest, src, subset, nv )
#define QDP_C_vpeq_C( dest, src, subset, nv ) \
        QDP_F_C_vpeq_C( dest, src, subset, nv )
#define QDP_R_vmeq_R( dest, src, subset, nv ) \
        QDP_F_R_vmeq_R( dest, src, subset, nv )
#define QDP_C_vmeq_C( dest, src, subset, nv ) \
        QDP_F_C_vmeq_C( dest, src, subset, nv )
#define QDP_C_eq_conj_C( dest, src, subset ) \
        QDP_F_C_eq_conj_C( dest, src, subset )
#define QDP_C_peq_conj_C( dest, src, subset ) \
        QDP_F_C_peq_conj_C( dest, src, subset )
#define QDP_C_meq_conj_C( dest, src, subset ) \
        QDP_F_C_meq_conj_C( dest, src, subset )
#define QDP_C_eqm_conj_C( dest, src, subset ) \
        QDP_F_C_eqm_conj_C( dest, src, subset )
#define QDP_C_eq_Ca( dest, src, subset ) \
        QDP_F_C_eq_Ca( dest, src, subset )
#define QDP_C_peq_Ca( dest, src, subset ) \
        QDP_F_C_peq_Ca( dest, src, subset )
#define QDP_C_meq_Ca( dest, src, subset ) \
        QDP_F_C_meq_Ca( dest, src, subset )
#define QDP_C_eqm_Ca( dest, src, subset ) \
        QDP_F_C_eqm_Ca( dest, src, subset )
#define QDP_R_eq_norm2_C( dest, src, subset ) \
        QDP_F_R_eq_norm2_C( dest, src, subset )
#define QDP_C_eq_R( dest, src, subset ) \
        QDP_F_C_eq_R( dest, src, subset )
#define QDP_C_eq_R_plus_i_R( dest, src1, src2, subset ) \
        QDP_F_C_eq_R_plus_i_R( dest, src1, src2, subset )
#define QDP_R_eq_re_C( dest, src, subset ) \
        QDP_F_R_eq_re_C( dest, src, subset )
#define QDP_R_eq_im_C( dest, src, subset ) \
        QDP_F_R_eq_im_C( dest, src, subset )
#define QDP_R_eq_I( dest, src, subset ) \
        QDP_F_R_eq_I( dest, src, subset )
#define QDP_I_eq_trunc_R( dest, src, subset ) \
        QDP_F_I_eq_trunc_R( dest, src, subset )
#define QDP_I_eq_round_R( dest, src, subset ) \
        QDP_F_I_eq_round_R( dest, src, subset )
#define QDP_R_eq_r_times_R( dest, src1, src2, subset ) \
        QDP_F_R_eq_r_times_R( dest, src1, src2, subset )
#define QDP_C_eq_r_times_C( dest, src1, src2, subset ) \
        QDP_F_C_eq_r_times_C( dest, src1, src2, subset )
#define QDP_R_peq_r_times_R( dest, src1, src2, subset ) \
        QDP_F_R_peq_r_times_R( dest, src1, src2, subset )
#define QDP_C_peq_r_times_C( dest, src1, src2, subset ) \
        QDP_F_C_peq_r_times_C( dest, src1, src2, subset )
#define QDP_R_meq_r_times_R( dest, src1, src2, subset ) \
        QDP_F_R_meq_r_times_R( dest, src1, src2, subset )
#define QDP_C_meq_r_times_C( dest, src1, src2, subset ) \
        QDP_F_C_meq_r_times_C( dest, src1, src2, subset )
#define QDP_R_eqm_r_times_R( dest, src1, src2, subset ) \
        QDP_F_R_eqm_r_times_R( dest, src1, src2, subset )
#define QDP_C_eqm_r_times_C( dest, src1, src2, subset ) \
        QDP_F_C_eqm_r_times_C( dest, src1, src2, subset )
#define QDP_C_eq_c_times_C( dest, src1, src2, subset ) \
        QDP_F_C_eq_c_times_C( dest, src1, src2, subset )
#define QDP_C_peq_c_times_C( dest, src1, src2, subset ) \
        QDP_F_C_peq_c_times_C( dest, src1, src2, subset )
#define QDP_C_meq_c_times_C( dest, src1, src2, subset ) \
        QDP_F_C_meq_c_times_C( dest, src1, src2, subset )
#define QDP_C_eqm_c_times_C( dest, src1, src2, subset ) \
        QDP_F_C_eqm_c_times_C( dest, src1, src2, subset )
#define QDP_C_eq_i_C( dest, src, subset ) \
        QDP_F_C_eq_i_C( dest, src, subset )
#define QDP_C_peq_i_C( dest, src, subset ) \
        QDP_F_C_peq_i_C( dest, src, subset )
#define QDP_C_meq_i_C( dest, src, subset ) \
        QDP_F_C_meq_i_C( dest, src, subset )
#define QDP_C_eqm_i_C( dest, src, subset ) \
        QDP_F_C_eqm_i_C( dest, src, subset )
#define QDP_R_eq_R_mod_R( dest, src1, src2, subset ) \
        QDP_F_R_eq_R_mod_R( dest, src1, src2, subset )
#define QDP_R_eq_R_max_R( dest, src1, src2, subset ) \
        QDP_F_R_eq_R_max_R( dest, src1, src2, subset )
#define QDP_R_eq_R_min_R( dest, src1, src2, subset ) \
        QDP_F_R_eq_R_min_R( dest, src1, src2, subset )
#define QDP_R_eq_R_pow_R( dest, src1, src2, subset ) \
        QDP_F_R_eq_R_pow_R( dest, src1, src2, subset )
#define QDP_R_eq_R_atan2_R( dest, src1, src2, subset ) \
        QDP_F_R_eq_R_atan2_R( dest, src1, src2, subset )
#define QDP_R_eq_R_ldexp_I( dest, src1, src2, subset ) \
        QDP_F_R_eq_R_ldexp_I( dest, src1, src2, subset )
#define QDP_R_eq_R_plus_R( dest, src1, src2, subset ) \
        QDP_F_R_eq_R_plus_R( dest, src1, src2, subset )
#define QDP_C_eq_C_plus_C( dest, src1, src2, subset ) \
        QDP_F_C_eq_C_plus_C( dest, src1, src2, subset )
#define QDP_R_eq_R_minus_R( dest, src1, src2, subset ) \
        QDP_F_R_eq_R_minus_R( dest, src1, src2, subset )
#define QDP_C_eq_C_minus_C( dest, src1, src2, subset ) \
        QDP_F_C_eq_C_minus_C( dest, src1, src2, subset )
#define QDP_R_eq_R_times_R( dest, src1, src2, subset ) \
        QDP_F_R_eq_R_times_R( dest, src1, src2, subset )
#define QDP_C_eq_C_times_C( dest, src1, src2, subset ) \
        QDP_F_C_eq_C_times_C( dest, src1, src2, subset )
#define QDP_R_peq_R_times_R( dest, src1, src2, subset ) \
        QDP_F_R_peq_R_times_R( dest, src1, src2, subset )
#define QDP_C_peq_C_times_C( dest, src1, src2, subset ) \
        QDP_F_C_peq_C_times_C( dest, src1, src2, subset )
#define QDP_R_meq_R_times_R( dest, src1, src2, subset ) \
        QDP_F_R_meq_R_times_R( dest, src1, src2, subset )
#define QDP_C_meq_C_times_C( dest, src1, src2, subset ) \
        QDP_F_C_meq_C_times_C( dest, src1, src2, subset )
#define QDP_R_eqm_R_times_R( dest, src1, src2, subset ) \
        QDP_F_R_eqm_R_times_R( dest, src1, src2, subset )
#define QDP_C_eqm_C_times_C( dest, src1, src2, subset ) \
        QDP_F_C_eqm_C_times_C( dest, src1, src2, subset )
#define QDP_R_eq_R_divide_R( dest, src1, src2, subset ) \
        QDP_F_R_eq_R_divide_R( dest, src1, src2, subset )
#define QDP_C_eq_C_divide_C( dest, src1, src2, subset ) \
        QDP_F_C_eq_C_divide_C( dest, src1, src2, subset )
#define QDP_C_eq_C_dot_C( dest, src1, src2, subset ) \
        QDP_F_C_eq_C_dot_C( dest, src1, src2, subset )
#define QDP_R_eq_re_C_dot_C( dest, src1, src2, subset ) \
        QDP_F_R_eq_re_C_dot_C( dest, src1, src2, subset )
#define QDP_R_eq_r_times_R_plus_R( dest, c, src1, src2, subset ) \
        QDP_F_R_eq_r_times_R_plus_R( dest, c, src1, src2, subset )
#define QDP_C_eq_r_times_C_plus_C( dest, c, src1, src2, subset ) \
        QDP_F_C_eq_r_times_C_plus_C( dest, c, src1, src2, subset )
#define QDP_R_eq_r_times_R_minus_R( dest, c, src1, src2, subset ) \
        QDP_F_R_eq_r_times_R_minus_R( dest, c, src1, src2, subset )
#define QDP_C_eq_r_times_C_minus_C( dest, c, src1, src2, subset ) \
        QDP_F_C_eq_r_times_C_minus_C( dest, c, src1, src2, subset )
#define QDP_C_eq_c_times_C_plus_C( dest, c, src1, src2, subset ) \
        QDP_F_C_eq_c_times_C_plus_C( dest, c, src1, src2, subset )
#define QDP_C_eq_c_times_C_minus_C( dest, c, src1, src2, subset ) \
        QDP_F_C_eq_c_times_C_minus_C( dest, c, src1, src2, subset )
#define QDP_I_eq_R_eq_R( dest, src1, src2, subset ) \
        QDP_F_I_eq_R_eq_R( dest, src1, src2, subset )
#define QDP_I_eq_R_ne_R( dest, src1, src2, subset ) \
        QDP_F_I_eq_R_ne_R( dest, src1, src2, subset )
#define QDP_I_eq_R_gt_R( dest, src1, src2, subset ) \
        QDP_F_I_eq_R_gt_R( dest, src1, src2, subset )
#define QDP_I_eq_R_lt_R( dest, src1, src2, subset ) \
        QDP_F_I_eq_R_lt_R( dest, src1, src2, subset )
#define QDP_I_eq_R_ge_R( dest, src1, src2, subset ) \
        QDP_F_I_eq_R_ge_R( dest, src1, src2, subset )
#define QDP_I_eq_R_le_R( dest, src1, src2, subset ) \
        QDP_F_I_eq_R_le_R( dest, src1, src2, subset )
#define QDP_R_eq_R_mask_I( dest, src1, src2, subset ) \
        QDP_F_R_eq_R_mask_I( dest, src1, src2, subset )
#define QDP_C_eq_C_mask_I( dest, src1, src2, subset ) \
        QDP_F_C_eq_C_mask_I( dest, src1, src2, subset )
#define QDP_r_eq_norm2_I( dest, src, subset ) \
        QDP_F_r_eq_norm2_I( dest, src, subset )
#define QDP_r_eq_norm2_R( dest, src, subset ) \
        QDP_F_r_eq_norm2_R( dest, src, subset )
#define QDP_r_eq_norm2_C( dest, src, subset ) \
        QDP_F_r_eq_norm2_C( dest, src, subset )
#define QDP_r_veq_norm2_I( dest, src, subset, nv ) \
        QDP_F_r_veq_norm2_I( dest, src, subset, nv )
#define QDP_r_veq_norm2_R( dest, src, subset, nv ) \
        QDP_F_r_veq_norm2_R( dest, src, subset, nv )
#define QDP_r_veq_norm2_C( dest, src, subset, nv ) \
        QDP_F_r_veq_norm2_C( dest, src, subset, nv )
#define QDP_r_eq_I_dot_I( dest, src1, src2, subset ) \
        QDP_F_r_eq_I_dot_I( dest, src1, src2, subset )
#define QDP_r_eq_R_dot_R( dest, src1, src2, subset ) \
        QDP_F_r_eq_R_dot_R( dest, src1, src2, subset )
#define QDP_r_veq_I_dot_I( dest, src1, src2, subset, nv ) \
        QDP_F_r_veq_I_dot_I( dest, src1, src2, subset, nv )
#define QDP_r_veq_R_dot_R( dest, src1, src2, subset, nv ) \
        QDP_F_r_veq_R_dot_R( dest, src1, src2, subset, nv )
#define QDP_c_eq_C_dot_C( dest, src1, src2, subset ) \
        QDP_F_c_eq_C_dot_C( dest, src1, src2, subset )
#define QDP_c_veq_C_dot_C( dest, src1, src2, subset, nv ) \
        QDP_F_c_veq_C_dot_C( dest, src1, src2, subset, nv )
#define QDP_r_eq_re_C_dot_C( dest, src1, src2, subset ) \
        QDP_F_r_eq_re_C_dot_C( dest, src1, src2, subset )
#define QDP_r_veq_re_C_dot_C( dest, src1, src2, subset, nv ) \
        QDP_F_r_veq_re_C_dot_C( dest, src1, src2, subset, nv )
#define QDP_r_eq_sum_I( dest, src, subset ) \
        QDP_F_r_eq_sum_I( dest, src, subset )
#define QDP_r_eq_sum_R( dest, src, subset ) \
        QDP_F_r_eq_sum_R( dest, src, subset )
#define QDP_c_eq_sum_C( dest, src, subset ) \
        QDP_F_c_eq_sum_C( dest, src, subset )
#define QDP_r_eq_norm2_I_multi( dest, src, subset, ns ) \
        QDP_F_r_eq_norm2_I_multi( dest, src, subset, ns )
#define QDP_r_eq_norm2_R_multi( dest, src, subset, ns ) \
        QDP_F_r_eq_norm2_R_multi( dest, src, subset, ns )
#define QDP_r_eq_norm2_C_multi( dest, src, subset, ns ) \
        QDP_F_r_eq_norm2_C_multi( dest, src, subset, ns )
#define QDP_r_veq_norm2_I_multi( dest, src, subset, ns ) \
        QDP_F_r_veq_norm2_I_multi( dest, src, subset, ns )
#define QDP_r_veq_norm2_R_multi( dest, src, subset, ns ) \
        QDP_F_r_veq_norm2_R_multi( dest, src, subset, ns )
#define QDP_r_veq_norm2_C_multi( dest, src, subset, ns ) \
        QDP_F_r_veq_norm2_C_multi( dest, src, subset, ns )
#define QDP_r_eq_I_dot_I_multi( dest, src1, src2, subset, ns ) \
        QDP_F_r_eq_I_dot_I_multi( dest, src1, src2, subset, ns )
#define QDP_r_eq_R_dot_R_multi( dest, src1, src2, subset, ns ) \
        QDP_F_r_eq_R_dot_R_multi( dest, src1, src2, subset, ns )
#define QDP_r_veq_I_dot_I_multi( dest, src1, src2, subset, ns ) \
        QDP_F_r_veq_I_dot_I_multi( dest, src1, src2, subset, ns )
#define QDP_r_veq_R_dot_R_multi( dest, src1, src2, subset, ns ) \
        QDP_F_r_veq_R_dot_R_multi( dest, src1, src2, subset, ns )
#define QDP_c_eq_C_dot_C_multi( dest, src1, src2, subset, ns ) \
        QDP_F_c_eq_C_dot_C_multi( dest, src1, src2, subset, ns )
#define QDP_c_veq_C_dot_C_multi( dest, src1, src2, subset, ns ) \
        QDP_F_c_veq_C_dot_C_multi( dest, src1, src2, subset, ns )
#define QDP_r_eq_re_C_dot_C_multi( dest, src1, src2, subset, ns ) \
        QDP_F_r_eq_re_C_dot_C_multi( dest, src1, src2, subset, ns )
#define QDP_r_veq_re_C_dot_C_multi( dest, src1, src2, subset, ns ) \
        QDP_F_r_veq_re_C_dot_C_multi( dest, src1, src2, subset, ns )
#define QDP_r_eq_sum_I_multi( dest, src, subset, ns ) \
        QDP_F_r_eq_sum_I_multi( dest, src, subset, ns )
#define QDP_r_eq_sum_R_multi( dest, src, subset, ns ) \
        QDP_F_r_eq_sum_R_multi( dest, src, subset, ns )
#define QDP_c_eq_sum_C_multi( dest, src, subset, ns ) \
        QDP_F_c_eq_sum_C_multi( dest, src, subset, ns )

#endif
