#include <stdlib.h>
#include "qdp_d.h"
#include "qdp_d_internal.h"

QDP_D_Real *
QDP_D_create_R(void)
{
  QDP_D_Real *m;

  m = (QDP_D_Real *) malloc(sizeof(QDP_D_Real));
  if(m!=NULL) {
    m->data = NULL;
    m->ptr = NULL;
    m->dc.data = (char **) &(m->data);
    m->dc.ptr = (char ***) &(m->ptr);
    m->dc.size = sizeof(QLA_D_Real);
    m->dc.discarded = 1;
    m->dc.exposed = 0;
    m->dc.shift_src = NULL;
    m->dc.shift_dest = NULL;
  }

  return m;
}

void
QDP_D_destroy_R(QDP_D_Real *field)
{
  QDP_prepare_destroy(&field->dc);
  free(field->data);
  free(field->ptr);
  free(field);
}
