/*
 *  Fills and random numbers
 *
 *  Zero fills
 */

#include "qdp_d3_internal.h"

void
QDP_D3_D_eq_zero( QDP_D3_DiracFermion *__restrict__ dest, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);

  if( subset->indexed ) {
    QLA_D3_D_xeq_zero( dest->data, subset->index, subset->len );
  } else {
    QLA_D3_D_veq_zero( dest->data+subset->offset, subset->len );
  }
}
