/*
 *  Fills and random numbers
 *
 *  Constant fills
 */

#include "qdp_d3_internal.h"

void
QDP_D3_H_eq_h( QDP_D3_HalfFermion *__restrict__ dest, QLA_D3_HalfFermion *src, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);

  if( subset->indexed ) {
    QLA_D3_H_xeq_h( dest->data, src, subset->index, subset->len );
  } else {
    QLA_D3_H_veq_h( dest->data+subset->offset, src, subset->len );
  }
}
