/*
 *  Fills and random numbers
 *
 *  Constant fills
 */

#include "qdp_d3_internal.h"

void
QDP_D3_M_eq_m( QDP_D3_ColorMatrix *__restrict__ dest, QLA_D3_ColorMatrix *src, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);

  if( subset->indexed ) {
    QLA_D3_M_xeq_m( dest->data, src, subset->index, subset->len );
  } else {
    QLA_D3_M_veq_m( dest->data+subset->offset, src, subset->len );
  }
}
