/*
 *  Fills and random numbers
 *
 *  Constant fills
 */

#include "qdp_f3_internal.h"

void
QDP_F3_V_eq_v( QDP_F3_ColorVector *__restrict__ dest, QLA_F3_ColorVector *src, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);

  if( subset->indexed ) {
    QLA_F3_V_xeq_v( dest->data, src, subset->index, subset->len );
  } else {
    QLA_F3_V_veq_v( dest->data+subset->offset, src, subset->len );
  }
}
